#include <stdio.h>
#include <stdlib.h>

int main() {
	unsigned char ram[2048*16];
	int x, word, word2;
	int state=0;
	x=read(0, ram, 2048*16);
	printf("ROM space: %i bytes.\n", x);
	for (x=0; x<2048*8; x+=2) {
		word=ram[x]|(ram[x+1]<<8);
		printf("%04x: %04x", x, word);
		if ((word&0xE000)==0x0000) {
			x+=2;
			word2=ram[x]|(ram[x+1]<<8);
			printf(" %04x\t", word2);
			printf("DRAW (%i,%i) intens=%i\n", word2&0xFFF, word&0xFFF, word2>>12);
		} else if ((word&0xE000)==0x2000) {
			printf("\tHALT\n");
		} else if ((word&0xE000)==0x4000) {
			printf("\tDRAWSHORT (%i, %i) intens=%i\n", (word&0x1F), (word&0x1F00)>>8, (word&0xE)>>5);
		} else if ((word&0xF000)==0x6000) {
			printf("\tCOLOR %i, intens=%i\n", word&0x7, (word&0xF)>>4);
//			printf("\tCOLOR %i, intens=%i\n", (word&0x700)>>8, word&0xFF);
		} else if ((word&0xF000)==0x7000) {
			printf("\tSCALE %i\n", word&0x7FF);
		} else if ((word&0xE000)==0x8000) {
			printf("\tCENTER\n");
		} else if ((word&0xE000)==0xA000) {
			printf("\tCALL %04x\n", (word&0x1FFF)<<1);
		} else if ((word&0xE000)==0xC000) {
			printf("\tRETURN\n");
		} else if ((word&0xE000)==0xE000) {
			printf("\tJUMP %04x\n", (word&0x1FFF)<<1);
		}
	}
}