-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgmf is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgmf is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "8181810141C14181610101A1767263696C60636B616262696C6F6A636E605F58";
    attribute INIT_01 of inst : label is "010101010101010101010101010101010102A101910121111111116181812181";
    attribute INIT_02 of inst : label is "E66C4B2C606E8EC022EE83EC0ECE64A5E6C8640EC006098E020EE62501010101";
    attribute INIT_03 of inst : label is "444A6064AB06E8E2E4A0E80EC86CA0AAE84F082C62E8808ECE64A808EEE28B08";
    attribute INIT_04 of inst : label is "66C6060A2008E8C0E040A8AC66C60608E2608EC0E7EE2EE8ECE64A18EE28166C";
    attribute INIT_05 of inst : label is "4C620E2064AEAEC66A6060AEA0E8C0E706E00EC66C6060E8460E6A00E8E2CAEC";
    attribute INIT_06 of inst : label is "4AE20EE800E4E8C00420A58E2064A08E24002CE280EC08E08E2C6AA6CA0C0EC0";
    attribute INIT_07 of inst : label is "AE2428EC0E02C0AA6CA0C42680E02E58668E6A0686406CC68E406C0E862C0CEA";
    attribute INIT_08 of inst : label is "640E86006E6842C26C4A68000E200EAAEE8C0E8602ECAE882A0C06E60EE008EA";
    attribute INIT_09 of inst : label is "EAA4A6064AB06E8E2E4A0E80EEE600020CC64022C620AA6C8086026AAECEA068";
    attribute INIT_0A of inst : label is "C0EC04AE404A6064AB06E8E2E4A0E80EAA6CA0C426804C6206CCEA6006C0CAEC";
    attribute INIT_0B of inst : label is "EE6C8AE028B4A6064AB06E8E2E4A0E80E062E802C0C86CA0AAE840C060AA6CA0";
    attribute INIT_0C of inst : label is "A02C00000C224A20CE06020C68280E6E060C0E0628024EE6C40C6E880EE8EC00";
    attribute INIT_0D of inst : label is "80E6CCEA6006C00000AE02800E062A06E8E2E4A6064AB4A0E80EAE0280CAECC2";
    attribute INIT_0E of inst : label is "206E0CCE26AEAE640AEC0E86EC28C061A062A0C8EA06C06E8E2E4A6064AB4A0E";
    attribute INIT_0F of inst : label is "0A8EEE28060EAE6404DA66C4060062A04666C40EE805A64A600EC8EA0660E08E";
    attribute INIT_10 of inst : label is "EEE28040EAE6404066C4040062A049A22EE80606CE02E04DECE64A06080EEE04";
    attribute INIT_11 of inst : label is "28040AEAE6406D66C4040A062A06622EE80406CE02E040CE64A040E80EEE0408";
    attribute INIT_12 of inst : label is "6CE8A666444CEAE0686C600D22EE8040A6CE02E06DCE64A0400E80EEE06D8EEE";
    attribute INIT_13 of inst : label is "0ECE64A060EEE606E04EE8066EEE606E0C6CE8A0600A2C6CE8A00EC6CE8A00AC";
    attribute INIT_14 of inst : label is "0AE028E0EE664A0AE028E068E0E08EC64A0AE028C2E606E0A22EE8063EEE606E";
    attribute INIT_15 of inst : label is "8E284A0E8080AE0280C4E04CE0600C6822E6E060ACE0EC006C6A0AE02880ECE8";
    attribute INIT_16 of inst : label is "E0620C86CA046E04A6064A806E8E284A0E8080EE6208E40AE06C04A6064A806E";
    attribute INIT_17 of inst : label is "4A6064A806E8E284A0E8080EE6C0EE620E268E0604A6064A806E8E284A0E8080";
    attribute INIT_18 of inst : label is "AE8400E4C0E8600CC24CCE66C40AEE620C8644EE6CEEE6A6E4026C68CA02EEC9";
    attribute INIT_19 of inst : label is "E82AA086ECA02C5AEE6C086ECA02C6AE82AA086ECA02C3CAEC0820840C86CA0A";
    attribute INIT_1A of inst : label is "2680404AEE0C0EC008ECC60AE0280C6620EA6EC4006AE80E286EBAEE6C0C060A";
    attribute INIT_1B of inst : label is "6ECA8E82026C00E4C0A2E80C224ABAC062408200AA6ECA8E82026CA404AEE0C4";
    attribute INIT_1C of inst : label is "A04C620A2E80EC60E820C224A84AC6406E4C0E820E808E200020A22E04AE4CAA";
    attribute INIT_1D of inst : label is "020980D09808C300980DAF280D80D90D8030C5779B57698A09F8F8F8E8026CE6";
    attribute INIT_1E of inst : label is "8A883C80D7FD99E0870D60D50D40D30D20D10D00D70D60D50D40D30D20D10D05";
    attribute INIT_1F of inst : label is "0D407940D70D0D5D00980D40C510F46FD88D8BD6ED08D0BD8AC63060997FD888";
    attribute INIT_20 of inst : label is "96AB596AA595AA95540D308FC30590563030F9458595466DD6CD606DD8009F98";
    attribute INIT_21 of inst : label is "0D69B030E00C5958580D05A9150980DE0A91516B00980DD0A9053010D80D9595";
    attribute INIT_22 of inst : label is "0C6A0F48620766066966BD49860C5D6BDA396FD44DE99044EE0F442D095042E3";
    attribute INIT_23 of inst : label is "AAB002A5080602A30009890DAA708100098120006AA1208A88880D90DE620D66";
    attribute INIT_24 of inst : label is "40801E305000A90DB080CB080C42C001E8200EAA822200922A2020F920AA7006";
    attribute INIT_25 of inst : label is "08000090040161690DB0850AAA000101A70011215198B0805A02AF2A0C40A30A";
    attribute INIT_26 of inst : label is "281920209900C01E2020F915800520822519150425879AAC9A30250016A7C608";
    attribute INIT_27 of inst : label is "C006402615AAAA158005D0800A90DB080CB080C9001ED0800A90DB080CB080C0";
    attribute INIT_28 of inst : label is "91509400915808B5202690D16B0801A2509150905840A30D20D10DA0945F990D";
    attribute INIT_29 of inst : label is "069086580A500AD0AD525580A508AD8AD5205E04D2209A0B5A520891589F2800";
    attribute INIT_2A of inst : label is "B0000289730E9027F0497009529751DD690C01BD1EDC8C941DC0069075A01DD2";
    attribute INIT_2B of inst : label is "6328B0008269790E0A16D30158B0006925898A2679016B0A592266282019C208";
    attribute INIT_2C of inst : label is "3DBAC71909B9CA7925264509604673CE9E20C8080167D0D5ED49BAC304500161";
    attribute INIT_2D of inst : label is "0E902FF000000066442200673CE922820251940792544790730F94271989709B";
    attribute INIT_2E of inst : label is "DFDE0730E9E22026730E9A2BDCE90270257F0879F9258B0B3EBC924790246073";
    attribute INIT_2F of inst : label is "9E28B0B2C49141662B016730E9628B0CDE0914166280019790E6480080884EFE";
    attribute INIT_30 of inst : label is "006730F9A20509730F96248C048CE4A06C200509CCC562006900980DB016730E";
    attribute INIT_31 of inst : label is "1855097579658916728B08200091016A836D30819888DA8BD3508DA0BD16F205";
    attribute INIT_32 of inst : label is "525F980D15F900D05F980D340F00965898658B082000920768A8D308198F9F95";
    attribute INIT_33 of inst : label is "049F980D02D0901D09B080C9630AB080CB080C82001C4000D0970F9250915090";
    attribute INIT_34 of inst : label is "0D1C80919207955E0C9958509DBC60AA80D00D62099696DF0DE0600980DF0866";
    attribute INIT_35 of inst : label is "0E096BDBACAB3BCA9A4DACC8C300980D90D80DA509760790DB0730E9027F0497";
    attribute INIT_36 of inst : label is "D308AAAA88088E0208D0970A80D00D09F28FD0FD798FD0FD0908DDD8DED96224";
    attribute INIT_37 of inst : label is "8002E3001D29801D11A811100D80D79D6E808D808D5DD4E08DD08A880F950F98";
    attribute INIT_38 of inst : label is "00D7910A251025050579F9AAAA800DE00980D90D80D80D600980DD0051025F98";
    attribute INIT_39 of inst : label is "270E00646408155931158058981535094509E7C80D60A802DE09AE8DE0C01D09";
    attribute INIT_3A of inst : label is "11B953111115B511E6C7ED6ED097ED7ED6ED6ED72D62D0088A098A860D70D190";
    attribute INIT_3B of inst : label is "00E0E0000007201010000000E0E0000007201010000000E0E000002010100000";
    attribute INIT_3C of inst : label is "00000000000000000F0005000300001001001F00E0E00000072010100000001F";
    attribute INIT_3D of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3F of inst : label is "7D7F7F0000000000000000000000000000000000000000000000000000000000";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "F2FE02629693A4375F276706E2E0EEECEBEBEAE8E7E6E5E4E2E1E1E1E0E0ECEF";
    attribute INIT_01 of inst : label is "E2F2D254474747475712C2C2C2C22202326C51B282A291A2A2A2A25CD2E7929C";
    attribute INIT_02 of inst : label is "14123EB11322313032132D913121233E9233130110322DB14301212E47273747";
    attribute INIT_03 of inst : label is "3FA323133EB12312EA13132EB3133033133D83311232E83121233E8331332E83";
    attribute INIT_04 of inst : label is "123232033404133310343BB212323203334031331C932132EA1233FC1332FC12";
    attribute INIT_05 of inst : label is "23240123121BB121212320333013331CB210312123232013220123031112AB12";
    attribute INIT_06 of inst : label is "211402340312131023332BB12312103333033333101204133333AA1233032120";
    attribute INIT_07 of inst : label is "3333BB133103302123303222301432BB121211013130122231301201322AB213";
    attribute INIT_08 of inst : label is "13013220122333AA2321230331403121133101322B9311333101313303120413";
    attribute INIT_09 of inst : label is "139A323133EB12312EA13132E921202302212043124021121CB1332111213013";
    attribute INIT_0A of inst : label is "3212023339A323133EB12312EA13132EA1233032223023240432312222103112";
    attribute INIT_0B of inst : label is "1223EB33318A323133EB12312EA13132EB221103303313303313301310212330";
    attribute INIT_0C of inst : label is "10330000033323B821423E81132E8311423D81414E8332123E83214E811331E8";
    attribute INIT_0D of inst : label is "32EC3231222210000033331001414BB12312EA323133EA13132EB33310311223";
    attribute INIT_0E of inst : label is "432101212DB11123031201323133332CB32310331332DB12312EA323133EA131";
    attribute INIT_0F of inst : label is "DB3313320001112300CB4123000323100DC12301132EB1212201331332DB1231";
    attribute INIT_10 of inst : label is "313320001112300DC123000323100DB3213200011133200C9212330004313200";
    attribute INIT_11 of inst : label is "3200031112300CC1230003323100DB213200011133200DA123300014313200DB";
    attribute INIT_12 of inst : label is "21131EA2444221202313105CB2132000311133200CA1233000314313200CB313";
    attribute INIT_13 of inst : label is "012123300DA3223220431200DA322322032113100D833321131A81321132A833";
    attribute INIT_14 of inst : label is "033331C8133121033331C8431410311233033331BB22322033213200DA322322";
    attribute INIT_15 of inst : label is "312EA13132E83333103413EA1423E9132EB11423DA1412E81111033331C81112";
    attribute INIT_16 of inst : label is "14140331330412CA323133EB12312EA13132E812120313031422CA323133EB12";
    attribute INIT_17 of inst : label is "A323133EB12312EA13132E812230121201213141CA323133EB12312EA13132E8";
    attribute INIT_18 of inst : label is "3133031230132201232A914123031212C9312FA32112EC311FB323133333211D";
    attribute INIT_19 of inst : label is "13313031121033BB1223031121033DB13313031121033DB3130332E803313303";
    attribute INIT_1A of inst : label is "223CC0211203212C831111033331CB2140131123004331023311BB1223013103";
    attribute INIT_1B of inst : label is "1133133202130312303231033323AB332330332032113313320213BC02112032";
    attribute INIT_1C of inst : label is "1023240323101113132033323AA13120412301332110114022303221023339B2";
    attribute INIT_1D of inst : label is "0A0A808CA79140F1270A9FA8888C888870F698E4B98E4BA00ADCD6D0DAB32331";
    attribute INIT_1E of inst : label is "484ED48880F86ACDE20920920920920920920920900900900900900900900909";
    attribute INIT_1F of inst : label is "0A1D0C02A0D1F8A0F1270A1F8A11E202860A60802860A608EC4DB20D6C0FAD49";
    attribute INIT_20 of inst : label is "1208A1208A18449AD62B82E640D5C0ADB20D029A181A9E0280280F0240F62F48";
    attribute INIT_21 of inst : label is "D8FA4D0DC5DFA181A84808AA880A8880D0C8A8E0D4270A1FAC0A2D02A808981A";
    attribute INIT_22 of inst : label is "D7E03E27E0D7E0D7E7E0280E30992D02AA0202A0281A1102C11E20280A0102C0";
    attribute INIT_23 of inst : label is "9A4B0A00DC090A81D005C8888BFDE2D00BC0A0A08891A46A6A68C88887E0D7E0";
    attribute INIT_24 of inst : label is "ED86080D0CFDC888F1702F37026A0A608AA608A991A0FF28A81A0F028A8ADD09";
    attribute INIT_25 of inst : label is "ED92E2AE90E0A0E888EDCF9A082D050982D0B1A080AAFDE0980A9FAE04DDB0B4";
    attribute INIT_26 of inst : label is "AA0A0F1C0A6086081A0F020A0D0A8AAA080A08080AA02441E809082E0AE04D92";
    attribute INIT_27 of inst : label is "910CAF0C0844440A0D0AED8FDC888F1702F37020A608ED8FDC888F1702F37020";
    attribute INIT_28 of inst : label is "CC89A0D6CCA1FEC9FDCC888CEFDCC58C81AC83AC8AFDC009009009A0AD8FA888";
    attribute INIT_29 of inst : label is "ADA25D8F1C0D60C60A0AD8F1C0D60C60A0A608608AAFA0FC0CADD0AC82AFAD9F";
    attribute INIT_2A of inst : label is "120A4A4ADE25A2ADE20AAA6C80AD802ADA20D02002AED4C80280AD82D80F02A0";
    attribute INIT_2B of inst : label is "80AD120A5AFADF2D1CCAEC2CAD120AFAC80E38CADF2C81FCB0AC84AD120AE42D";
    attribute INIT_2C of inst : label is "7BE6B6F90AE6BA02CACEC80A01CEDE45AFA6EA2E1CCDF25CB5CBECB0FDB0ACAC";
    attribute INIT_2D of inst : label is "25A2AFF9944110101010101DE45A2AD12C80A0D02CACADF2DE25A0A6F9AA6F9E";
    attribute INIT_2E of inst : label is "919D6DE25ADAD1CCDE25ABAEA45ACA0DCADE2A02F4CAD12ECBEBBCADF2C80ADE";
    attribute INIT_2F of inst : label is "AEAD126AE2BCAC80AE1CCDE25AFAD12E1B9ACAC80AD120ADF2133311D1DDFD1D";
    attribute INIT_30 of inst : label is "1CCDE25A3AC82ADE25A4A5310ECA4310ECB6C82AE14CE09C00D2280AE1CCDE25";
    attribute INIT_31 of inst : label is "BAC80AC80AC87AC80AD12FA0ADAF1CC66C4EC2102460AE608C860AE608C80A6F";
    attribute INIT_32 of inst : label is "AC87280AC81280AC80270AC86C99CC8061CAD12FA0ADAF1CCC66EC2102472F4C";
    attribute INIT_33 of inst : label is "F22F470A0182A0180AF5702DEF1CF3702F17021A6608AA608460F74C260C210C";
    attribute INIT_34 of inst : label is "AE44AC00A0D02CA0D0CCAC82AE24F1CC6096090A0ACECEEF2E820D4280A19C02";
    attribute INIT_35 of inst : label is "90ECAECE7E2E2E1EAE9E64ED40D1270A888848D8CADA2DF2E72DE25A2ADE20AA";
    attribute INIT_36 of inst : label is "EC2244440466080A6080AF1C6096090A0A6086080A6086080A64E6B4E6BC80A0";
    attribute INIT_37 of inst : label is "7601E0901806101A1988190A6EE25CB5CBA62EE205CA5CA62ED20010F0209026";
    attribute INIT_38 of inst : label is "208CA2FA08DF0C0A0802F42222180AFD1270A8888488880F4270A0F0A1D08FAD";
    attribute INIT_39 of inst : label is "A0AED0C0EFDC0806090A1080AA08080A082AE04888F1C8209ECBAEBBEBB2086A";
    attribute INIT_3A of inst : label is "0021110000742100E542F82F88A2E82D82E82D82B82B8F186A161842892891A0";
    attribute INIT_3B of inst : label is "8430188420E020087084208430188420E0200870842084301860842008708420";
    attribute INIT_3C of inst : label is "00000000000000C042C0A1C0A1208452A184528430188420E020087084208452";
    attribute INIT_3D of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3F of inst : label is "EBE5E50000000000000000000000000000000000000000000000000000000000";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
