-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_vecc is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_vecc is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "7CC1D196196778940060CCCCC8484C4CA0007476146E1492345E9C009735334B";
    attribute INIT_01 of inst : label is "719687C900064C4C8C8444440A00C7899A7FA7F3F4490099B6C573D9B4A57700";
    attribute INIT_02 of inst : label is "00A0444448C8C4C460009C7869179ADFCF740079ABBCD77DCBBA970047FCFDA9";
    attribute INIT_03 of inst : label is "848CCCCC060049877691691D1CC700775A4B9D375C6B9900944F3F7AF7A9987C";
    attribute INIT_04 of inst : label is "3E007498A7F97631419C00976554399345567900C91413679F7A8947000AC4C4";
    attribute INIT_05 of inst : label is "1D1F4F22232D62B416BDEEFFC0ED4F00D2FF0E1F3E31202E60D535A0EEE0D1DE";
    attribute INIT_06 of inst : label is "112235AFC5EA1EFEEE1C3200C10D2E104113212055A1F6BB0EFEDFFE4F00C100";
    attribute INIT_07 of inst : label is "A13B2E1F0C3E1400ED1F003123F3022206BDB30A2E0EFD2D2300DE1F1F005204";
    attribute INIT_08 of inst : label is "2E41E300FC302203F2D1F202B5FAAF5B202F1D2F1400FC00311114E2D232E6CB";
    attribute INIT_09 of inst : label is "3E1102F1D2DFE0E2A03BDB6022203F32D2002D111300E3C0F1E2B31ABC6E232D";
    attribute INIT_0A of inst : label is "EFFDEFE0BB6F1A5502123114CF004100F1F1C1EEEFE1AE5CFA5322114025CF00";
    attribute INIT_0B of inst : label is "0A535D06E20213E3ED0032F1D100DE0CFFEEDB614B26D23222F4DE004101E2D0";
    attribute INIT_0C of inst : label is "E0E1F3C11C00F400FFFFFC2E1EFE2A456FD5E2F104B21C0023D100FFED1D0EEE";
    attribute INIT_0D of inst : label is "3E00E3FFFF002B401F2E5DF654A2EFE1E2CF2D00F4F0EE0F1C3F1E0E5B1661B5";
    attribute INIT_0E of inst : label is "EB383200FC904508D360DC094F00ED8D5248E483BEC84F00DE6A606604A6A0AA";
    attribute INIT_0F of inst : label is "DD084B7014003E38E584CED82B8C14002D6606A6C0AA0A6A2300FCA425D8C28C";
    attribute INIT_10 of inst : label is "BEC82C8D524ACF0032A6A0AA0C6A6066D20041C8B28DEC485E83E3004107B480";
    attribute INIT_11 of inst : label is "E3AA0A6A406606A6ED00F48CEB384E8425D8DE00F490CD063D805409CF002383";
    attribute INIT_12 of inst : label is "3200C1465E8324C8B28D2D00C1073CA0330AC3701C00D2D82B8C4238E5641C00";
    attribute INIT_13 of inst : label is "31031400C1D0E0FC22212EFEEFE02F30232300D2D2DFFE21202EEEE0E11E3F32";
    attribute INIT_14 of inst : label is "4113E3E30E00DEDE0D1E0212212EFEEE2122E31400C1DEFD0E1211300DFFEF20";
    attribute INIT_15 of inst : label is "1F1E02F3D2CF00FC0D0E4FE2F2222F1E0E1203D2D200EDED1D2FF202222E0EDE";
    attribute INIT_16 of inst : label is "E222202FF2D1DEDE002D2D3021E0E1F2222F2EF4E0D0CF00FC2D3F20E1F10330";
    attribute INIT_17 of inst : label is "FEFFD0031121E0DFED1C00413E2212EEEFE2122120E1D0EDED003E3E3112EFE0";
    attribute INIT_18 of inst : label is "F3C13E0EEEE20212EFFD2D2D00323203F20EFEEFE21222CF0E0D1C0041301302";
    attribute INIT_19 of inst : label is "F403D1E02F1F0DD0F1F20E1D304F00F423E2E12E1EEEE1F202FE0D3E3E002323";
    attribute INIT_1A of inst : label is "2300D2D3DFFE21202DEDE0E11E3F333200E3E3D0EF202F1EEEE1E21E2E324F00";
    attribute INIT_1B of inst : label is "23D31400C1C0FB1E02223F1DEEE02F31041400C1D1DE0E12203E0DEFE01F3024";
    attribute INIT_1C of inst : label is "0E1103C2D200EDDD1D2FF202323E0EFE2113D3E300DECE0D1F0212302D0EEF20";
    attribute INIT_1D of inst : label is "32201E02D2DFCF00FC0C5F21E0E213312E0E12F5C0CF00FCFD2D20E10223301E";
    attribute INIT_1E of inst : label is "E0D2032120F1D0ECED003E3D3112EFE0E323202FF2D1DDDE002D2C3011E0E103";
    attribute INIT_1F of inst : label is "F10EFED0E30221E0ED1D1C00414013F20EEED1F32220E1BF0C1C00413D3202FE";
    attribute INIT_20 of inst : label is "33E3E02F0EEDD0F202FF0D4E3E002333F3E11E0EDED20212EFFD3D2D00324203";
    attribute INIT_21 of inst : label is "00E3E4D0FF202F0DDEE0F20E3E334F00F404D1EF202EFDDFE202FE1D404F00F4";
    attribute INIT_22 of inst : label is "041400C1D1DF0E122F3E0DEEE02F21242300D2D3D0FE212F2DEDEFE11E303332";
    attribute INIT_23 of inst : label is "2103D3E300DECEFE1E0222302DFE0F2013D31400C1C0EC1E12213F1DFEEF2F22";
    attribute INIT_24 of inst : label is "2F1E12E4C0CF00FCFD1D20E11223302E0E12F2C2D200EDDD0D2FF212323E1EFE";
    attribute INIT_25 of inst : label is "E323212FF2D0DDDE002D2C2F21E0E20332211E02D1DFCF00FC0C4E21E1F21331";
    attribute INIT_26 of inst : label is "FEEFD1F31221E1CE0C1C00413D3102F0EFD2032220E1EFECED003E3D3012EFE1";
    attribute INIT_27 of inst : label is "03E11EFEDED2F212EF0D3D2D00324212F20EEED0E3F221E0FD1D1C00414022F2";
    attribute INIT_28 of inst : label is "F404E2EF2F1EFDDFE1F2FE2E404F00F433F3E00F1EEDD0E202FE1E4E3E002333";
    attribute INIT_29 of inst : label is "E43431FA4D0C0CCD1AC9EC3C424F5D3E00E3E4E1EF202E0DDEE1F00E3F334F00";
    attribute INIT_2A of inst : label is "1C5F6942534F0076423568C225221A5FCB9BFC4B870B4E5D415F4F004A415326";
    attribute INIT_2B of inst : label is "CEB0E4045C4355541B6F702C52A524533200C324159BC1F5134B517889FB5C74";
    attribute INIT_2C of inst : label is "98502435F415140064F4D5A2CEC3F36F3440403C617E4C43E414352300F334D5";
    attribute INIT_2D of inst : label is "B357FCBFD154F587785F45C7411576E4D51400A7E4B386ECB2E261155C5B4D54";
    attribute INIT_2E of inst : label is "F62744D4CEC1B3D200D1C1BF2A0BCEC045D4B5C551160742E5BAC2D5E300DCC2";
    attribute INIT_2F of inst : label is "CEDBA84EEBEEF6B1455534C58905C2B5CDB3CF00C6CFBDEA2CDCDF16C3040443";
    attribute INIT_30 of inst : label is "F5A190E4BE6BECBDDE004DECDB954F1BFDC5BF988715B49CF4B1A7CEBFCF009A";
    attribute INIT_31 of inst : label is "AC1C3B6E424D1DA1DCC0C0D4AF94C2CD2CFCDBED00FDFC1B62502C0CB4CFB9BC";
    attribute INIT_32 of inst : label is "98B1CB49CFFB9A2C1B1C00692C5D8A245E2EAFFBB4B7C1BC78B0ECBB3CDB1C00";
    attribute INIT_33 of inst : label is "00314D53E4054240CB1C7B4BBFFA09CE2B564E3B2D00344E5FB714513FBC1B89";
    attribute INIT_34 of inst : label is "C9C9CD0AE8DD1B50504D4F006742353E1B4EE83B5E0A0ABEDB28CEFB654E3B3E";
    attribute INIT_35 of inst : label is "3200F30405414D42946F5297770B1AC7EC3C6E40504F00A433164F2C50B65D50";
    attribute INIT_36 of inst : label is "2560602B5D822C5FB6245323004305B4525F3382603474740B3BA50B4E883361";
    attribute INIT_37 of inst : label is "051400CAD3A1144205AB35057C7C3C608E3D51050534140096E4B32351248E53";
    attribute INIT_38 of inst : label is "06C3C7C75053BA502488D3F6E300D1C0B0F234E4C916E599995E619C4E432604";
    attribute INIT_39 of inst : label is "B0C5CF00A9CEDBD2F5C228D5B206065235E84215ABC2D5D200D4B0CDE315D3E8";
    attribute INIT_3A of inst : label is "7CA1B0777925F64924D4A4C0B0CF006CDDFAC1E4B05AB3B0474743062833F5B0";
    attribute INIT_3B of inst : label is "5AECBDED00CD0B3CDEB1DD8EA0DC9C9C05D56B05C288DDAFDE00FD0C0BEFC3CE";
    attribute INIT_3C of inst : label is "0B65DB0B9494D4A082D3BF0B0BBC1C007A2C5DEDBFEC82BDEBA0A0E5B38EE6BF";
    attribute INIT_3D of inst : label is "EC883D1A2D003140501CDC2C47FA0B9779B0AF74C2CDCA0C0B1C00463D6FFCCE";
    attribute INIT_3E of inst : label is "3C4EC74C5F0808BFCC47CEDC864E1A3E003C50452BFB3D280A4D4949B0BD56B0";
    attribute INIT_3F of inst : label is "EC1B6E524E4F00C433F64F4E4FA55E51D8D7CDEB18DDEB72403B4F008642163E";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "5142425242535340C05043435242535340C0504342434252425341C050434243";
    attribute INIT_01 of inst : label is "52434350C04142425352434340C05142425352535340C05142425252535340C0";
    attribute INIT_02 of inst : label is "C04052524353424250C04152524353434350C04152525353434350C041525253";
    attribute INIT_03 of inst : label is "4243525241C04053534243424251C04053534343424251C04053534353424251";
    attribute INIT_04 of inst : label is "41C05043435242525241C05043434242525241C05043434243525241C0405353";
    attribute INIT_05 of inst : label is "434343424243425242535353525341C050534343434242434252425253525253";
    attribute INIT_06 of inst : label is "4242425352534353534340C05043434242424242425252534353535341C05042";
    attribute INIT_07 of inst : label is "52434343434340C05143424242524242425352434343534340C0514343424242";
    attribute INIT_08 of inst : label is "434250C05142424252525242525353434243434340C051424242425252425253";
    attribute INIT_09 of inst : label is "4142425252535252524353424242434250C04142424252525252524353434243";
    attribute INIT_0A of inst : label is "53535352534343424242424251C04042525252535352534353424242424251C0";
    attribute INIT_0B of inst : label is "434243425242425251C04052524253435353534243425242425251C040425252";
    attribute INIT_0C of inst : label is "5252525241C05042535353434353434243525252425241C04052425353434353";
    attribute INIT_0D of inst : label is "41C05053534243424343435242525352525341C0505253434343434343424252";
    attribute INIT_0E of inst : label is "534340C0514242425252534341C0514342425252535341C05143424242525253";
    attribute INIT_0F of inst : label is "5343434240C0414252525353434340C0414242525253434340C0514242525253";
    attribute INIT_10 of inst : label is "53534343424251C0405252534343424250C0405252535343434250C040425252";
    attribute INIT_11 of inst : label is "505343434242425251C0505353434342425251C0505253434342424251C04052";
    attribute INIT_12 of inst : label is "40C0504343424252525341C0504343424242525241C0505343434242525241C0";
    attribute INIT_13 of inst : label is "424240C05052525342424353535243424240C050525353424243535252434342";
    attribute INIT_14 of inst : label is "4242525004C05153434342424243535342425240C05053534342424243535342";
    attribute INIT_15 of inst : label is "434342525251C05143434352524243434342425250C051534343524242434353";
    attribute INIT_16 of inst : label is "5242424352525351C04143424252525242434352525251C05143434252524242";
    attribute INIT_17 of inst : label is "53535242424252535341C04043424253535242424252525351C0414342425352";
    attribute INIT_18 of inst : label is "525243435352424253534341C04042425243535352424253434341C040424242";
    attribute INIT_19 of inst : label is "5042525243434352525243434241C05042525243435352524253434341C04042";
    attribute INIT_1A of inst : label is "40C05052535342424353525243434240C05052525342434353525243434241C0";
    attribute INIT_1B of inst : label is "425240C05052534342424343535243424240C050525343424243435352434242";
    attribute INIT_1C of inst : label is "4342425250C05153434352424243435342425250C05153434342424243435342";
    attribute INIT_1D of inst : label is "42424342525351C05143434252524242434342525251C0515343425242424243";
    attribute INIT_1E of inst : label is "525242424252525351C04143424253525242424352525351C041434242525242";
    attribute INIT_1F of inst : label is "5243535252424252534341C04042425243535252424252534341C04043424253";
    attribute INIT_20 of inst : label is "42525243435352524253434341C04042525243435352424253534341C0404242";
    attribute INIT_21 of inst : label is "C05052525342434353525243434241C05042525342435353524253434241C050";
    attribute INIT_22 of inst : label is "4240C05052534342434343535243424240C05052525342434353535243424240";
    attribute INIT_23 of inst : label is "42425250C05153534342424243534342425240C0505253434242434353534342";
    attribute INIT_24 of inst : label is "434342525251C05153434252424242434342525250C051534343524242434353";
    attribute INIT_25 of inst : label is "5242424352525351C04143434252524242424342525351C05143434252524242";
    attribute INIT_26 of inst : label is "53535252424252534341C04043424252535242424252535351C0414342425352";
    attribute INIT_27 of inst : label is "425243535352524253434341C04042425243535252524252534341C040424252";
    attribute INIT_28 of inst : label is "5042525343435353525253434241C05042525243435352524253434341C04042";
    attribute INIT_29 of inst : label is "52424053434040534350534350434341C05052525342434353525243434241C0";
    attribute INIT_2A of inst : label is "434351424241C05142424152424043435050534350434351424341C051424241";
    attribute INIT_2B of inst : label is "4152524043425050434350434251424240C05142424152524043425050534350";
    attribute INIT_2C of inst : label is "51424241524240C04152524053525043425050434251434251424240C0514252";
    attribute INIT_2D of inst : label is "524053535042525151434251424241525240C041525240535250424251514342";
    attribute INIT_2E of inst : label is "5241425241525250C04052534043535042525151424241425241525250C04152";
    attribute INIT_2F of inst : label is "53535043535152524141425241425240535251C0405353504353514252414142";
    attribute INIT_30 of inst : label is "525240525340535351C04053535043435152534141425241525240535351C040";
    attribute INIT_31 of inst : label is "5043435142434152534040525340525340535351C05053435042434152534141";
    attribute INIT_32 of inst : label is "40525340535350434341C05043435142434153534040525340525350435341C0";
    attribute INIT_33 of inst : label is "C05043425142424053434040535340534350434341C050434351424241534340";
    attribute INIT_34 of inst : label is "5050534350534350424341C05142424143435043434040535340535350434341";
    attribute INIT_35 of inst : label is "40C05142424043425043425050434350534351424241C0514242414342504342";
    attribute INIT_36 of inst : label is "425050434350434351424240C041425240434250424250504343504343514242";
    attribute INIT_37 of inst : label is "4240C04152524042425142425151434251434241424240C04152524042425142";
    attribute INIT_38 of inst : label is "42525151424251424241525250C0405252504252514252515143425143424142";
    attribute INIT_39 of inst : label is "525251C04053535052524152524141424251424241525250C040525350425251";
    attribute INIT_3A of inst : label is "4152524141425241425240525251C04053535052524152524141424241425240";
    attribute INIT_3B of inst : label is "40535351C05043435152534152534141425241425240535351C0504343515253";
    attribute INIT_3C of inst : label is "434053434040525240525340435341C050434351535340535340405252415253";
    attribute INIT_3D of inst : label is "5350434341C05042424153434053434040525340525350434341C05043435153";
    attribute INIT_3E of inst : label is "43435043434040535340535350434341C0514242415343404343404052534052";
    attribute INIT_3F of inst : label is "534351424341C05142524143435043425050535340535350424341C051424241";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
