-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_vecd is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_vecd is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "5252338F52349383FB2BB61C2C8A356D32001325C4415F42826043A5B6DC0AE8";
    attribute INIT_01 of inst : label is "813D5EE704531400A8E4A12343249C441580801B4C942C4DA824612300650493";
    attribute INIT_02 of inst : label is "CEF215E4E806D4BAAB4D608E4E5126E5241400CCD5AD142414BA25F58D9D3C5E";
    attribute INIT_03 of inst : label is "44C942348AC2F6D200B6C0DBE3E5D318E5C3D9D85F52AB414268B336E300D1B2";
    attribute INIT_04 of inst : label is "BD3AC1C2C16BB2BF38394325F833259EC0D7CF008ACEFAD2D4C249C4B1080851";
    attribute INIT_05 of inst : label is "15E55AF4E486DDA1DE00FDEB2CEFB1CE8EA0CD6B5A34062824F5A2BEC4CF004C";
    attribute INIT_06 of inst : label is "682C6FEDCDEC74CCFB8080F5C47CE4C368ECAFED00AB0C5DDEBEDD81BEDC7D8D";
    attribute INIT_07 of inst : label is "65C3A082C2BFEA2BCC1C00443D61FCECFC56EB1B8373D4B28FD3B2290C9D1C00";
    attribute INIT_08 of inst : label is "005A40372B2B3DF82B4D3738B1BE65CFCEA83DFA2D003F5E441CFB2C280A3C56";
    attribute INIT_09 of inst : label is "FCE032D63C4DA3ED044F00EDCA41F93F9AB6BDD44F00DE964F2746C6E7CF763E";
    attribute INIT_0A of inst : label is "6CF47F1369AB3DCB14002DA91492A4AC9E1CA72300FCE533A567FD91FC643200";
    attribute INIT_0B of inst : label is "C1E9CA4A29419AD20041BCD3BA9631F74FC6E300410CE3AD4334DA3EC014003E";
    attribute INIT_0C of inst : label is "6BA9F39F14ACDE00F440DE3AD4C36D230ECF002346CF19DF765A335ECF00327A";
    attribute INIT_0D of inst : label is "CDDC36D2201C00D2A41C711DA765D5231C00E367FC7E6C6472F469ED00F44DDB";
    attribute INIT_0E of inst : label is "5BA6EDF34F00DE644F277898E7CFA43E00C1325D567AD117C14A2D00C1022D63";
    attribute INIT_0F of inst : label is "9E1CCA2300FCF134A45BCB91FC963200FCDC42C74FFCB4EC454F00EDA741F754";
    attribute INIT_10 of inst : label is "4FA9E300414BE49C1441C94EB414003E9AF49FC555AC3CDF14002DC614928789";
    attribute INIT_11 of inst : label is "CDCF002369CF19BCB54A431FCF0032ACC1E9987829416CD20041FDC3CA555CF9";
    attribute INIT_12 of inst : label is "1C00E34AFC7E898772F446ED00F43FDE6AB5457F147ADE00F454CE4BCFF47C24";
    attribute INIT_13 of inst : label is "00C1112D66BBB417C1672D00C1C32C541CC145C23C1C00D2761C714BBB66D211";
    attribute INIT_14 of inst : label is "C942E633DDA2EC764F0E00ED854017572DB4DD234F00DE334E369B7BD6CED33E";
    attribute INIT_15 of inst : label is "04919532CB3DD214002DD324A35957AD2CDD2300FCFE33C53E9B9F0CB83200FC";
    attribute INIT_16 of inst : label is "DA75953A423DD200412DD3BC235919408BE300417AE4AED33DEA4EA714003EB8";
    attribute INIT_17 of inst : label is "D275710458DE00F467CE2ADD336E249CCF00238BC0F9B9E35C33EFCF0032DDC2";
    attribute INIT_18 of inst : label is "D326C2491C00D2580C7F7BDE45D31E1C00E33DEC6DB7B963E433ED00F432DD4B";
    attribute INIT_19 of inst : label is "F0E1F20404FF00DDCEC9B3BBB9707000C1E13D54EDB7F7C0852D00C1942C623D";
    attribute INIT_1A of inst : label is "EF00134404D704FB0005DCE007B90912F2095904203C09FFFD0D071221102BEB";
    attribute INIT_1B of inst : label is "E1020F0705000B2103E10102C30001F102E200FF0F3E0FFF1F02F8F600DB0F04";
    attribute INIT_1C of inst : label is "EEFD0D483C0408FC00D7CD0F04EF0002323104C00000F8FC000E0705000B2103";
    attribute INIT_1D of inst : label is "04C8E0076400F1F0FF0E1F020600FF0E1F101102A400DF25E53F07DCC80D1D2E";
    attribute INIT_1E of inst : label is "02F200FE2D0FFF0F029E00F2041221102BEBF0E104F0F800204804E407080024";
    attribute INIT_1F of inst : label is "483404B40B2DED0B5407D4C8053304A000D7DFFE04DF0012323004C0000002F1";
    attribute INIT_20 of inst : label is "CBE007000000204B1D0DEC071300F1EF0E1F10021300FFE1021110027500D305";
    attribute INIT_21 of inst : label is "E100314004F00000CE000402E3001EFD1DFE029000E20622202BEBE0042C0DFD";
    attribute INIT_22 of inst : label is "1E07D000033735663104F2001E207B620AA29BE004FE0012D1A6D5D703DFEF04";
    attribute INIT_23 of inst : label is "001FFEE0F10211023300FE0E2B693E30232302F5070A001502E3E3D0DEA9EB0E";
    attribute INIT_24 of inst : label is "04E100102D0EEDF0F30213027F0011302CECD0F1E2022204F10211201EFF0208";
    attribute INIT_25 of inst : label is "04EC0024E12AD4F401AF04E2008F0400060000D4001E0CFEF100F10111F10111";
    attribute INIT_26 of inst : label is "C0BE7BED0E2E07CF0011F107FF00011434EA2104E4002C307C752C0EEC959CD0";
    attribute INIT_27 of inst : label is "0E3D302205F200FFE0F10111200204FC00EE0E2D9B5E404302C70704004702C3";
    attribute INIT_28 of inst : label is "B40202A100303EDED0C1F1114104E0F10111201F021200E2D0DD0E2E050E00EE";
    attribute INIT_29 of inst : label is "EBC9DDE0B4E3C7E60500FA0000FFE10211F102211F04AE0054100EFE0E1E0EF0";
    attribute INIT_2A of inst : label is "FA471F043C00D44A31F2060F06FAC604F00200000526472354203D492B1B06FB";
    attribute INIT_2B of inst : label is "A6BAE90A295A33043300DDA50304040FFEF45C2110046E00C2E0D723020C0FFA";
    attribute INIT_2C of inst : label is "CA043400DCFFC7FA060F02F4E337204204AE00F0E1BCFE0C0F04FC0365043D00";
    attribute INIT_2D of inst : label is "00000000000000000000000000000000000000000000F0FE004606060FF2FAD1";
    attribute INIT_2E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_2F of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_30 of inst : label is "08E20CCCC0C404C0E54808C0E20AEEE0E2060AEEE0E206C000C4084880C44480";
    attribute INIT_31 of inst : label is "06C0E304C4400008400C08C808EE6008A0C0E1C004CCC008C000AC0AAE08C008";
    attribute INIT_32 of inst : label is "C4440CCC8008C0E508A008C0000C084008C0E348C0EE44C4C0E540C00006A6AA";
    attribute INIT_33 of inst : label is "C8E3C44440C0E4C444C00044C00840C0E5C0E40860086008E6A60208A008C0E6";
    attribute INIT_34 of inst : label is "00A40860084008C0000408A008A008C0E7C4E54808C00088CC084C8004EF4808";
    attribute INIT_35 of inst : label is "0205032E310205E5F9ED600868E9C000044008C0004CC008A00860EE6008A0C0";
    attribute INIT_36 of inst : label is "68406860008604400C262E0CEE80E20422802000040EFBFAFDFA03D1EE0302FB";
    attribute INIT_37 of inst : label is "E8E1E9E4EEEBE7E4EEEAE3EEE7E1EFE8E4E8E0E3E1ECE5E8E0E8E0EEEEE200AC";
    attribute INIT_38 of inst : label is "3838EEEE0000C8CC0000383400EEEEFD00100000ECEDE7E8E9EAE3EFEAE6E0EE";
    attribute INIT_39 of inst : label is "1818E010ECEC14EC1010E818D4D41CE42828F000DCDC04FC2020F808C4C40CF4";
    attribute INIT_3A of inst : label is "FA100000F000E21400E1C838F4F43CC40808D020FCFC24DC0000D828E4E42CD4";
    attribute INIT_3B of inst : label is "0700003400000000C8001000E000000007001000FA1000FA1000FA1000FA1000";
    attribute INIT_3C of inst : label is "F0340000000007000050F9F000F950F91000F905F900F0F905F9000000F9FC00";
    attribute INIT_3D of inst : label is "00000000000000000000050600FB0A00FB06F108F4B0C400EE0007100000CC00";
    attribute INIT_3E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3F of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "4042425142425050534350434351424340C04142524043425042425050534350";
    attribute INIT_01 of inst : label is "50434351424240C04152524042425142425050434350434351424240C0414252";
    attribute INIT_02 of inst : label is "535042525142525151434251434241524240C041525340424251425251514343";
    attribute INIT_03 of inst : label is "4251424241525250C04052535052524152525151434251424241524250C04052";
    attribute INIT_04 of inst : label is "53435052524152534141424251424241525251C0405353505252415252414142";
    attribute INIT_05 of inst : label is "425241525240535251C05053435152534152534141424241425240535251C040";
    attribute INIT_06 of inst : label is "5043435153534053534040525241525240535351C05043435153534053534141";
    attribute INIT_07 of inst : label is "40525240525350435341C05043425153534053434040525241525240435341C0";
    attribute INIT_08 of inst : label is "C05142424143435043434040525340535350435341C051434241534340434340";
    attribute INIT_09 of inst : label is "51424252534252534341C051434252534252535341C051434342524252535341";
    attribute INIT_0A of inst : label is "425253435253434340C041424252535253434340C051424252535252534340C0";
    attribute INIT_0B of inst : label is "5253435343424250C040525253435253434250C040425253435253434240C041";
    attribute INIT_0C of inst : label is "43425343425251C050525343425343424251C040525343435343424251C04052";
    attribute INIT_0D of inst : label is "524342525241C050534342424342525241C050535343424342525251C0505353";
    attribute INIT_0E of inst : label is "4252535341C051434342524252535341C050434342524242525341C050434342";
    attribute INIT_0F of inst : label is "53434340C051424252535252534340C051434252535252534341C05143425252";
    attribute INIT_10 of inst : label is "434250C040425253435253434240C041425253535253434340C0414242525352";
    attribute INIT_11 of inst : label is "5251C040525343435343424251C040525253435343424250C040525253435353";
    attribute INIT_12 of inst : label is "41C050535343424342525251C050535343424343425251C05052534343534342";
    attribute INIT_13 of inst : label is "C050434342524242525341C050534342424242525341C0505343424243425252";
    attribute INIT_14 of inst : label is "4342525252525343410FC051434242524252534341C051434342524252535341";
    attribute INIT_15 of inst : label is "4252535253434240C041424252535253434340C051434252535253434340C051";
    attribute INIT_16 of inst : label is "53435343424250C040425253435343424250C040425253535353434240C04142";
    attribute INIT_17 of inst : label is "424342425251C050525343434343425251C040525253435343425251C0405252";
    attribute INIT_18 of inst : label is "4242525341C050534343424342525341C050535343424342525251C050525343";
    attribute INIT_19 of inst : label is "525252426C5360B4BAB3BEB8B3A6AAC050534342524252525341C05053434242";
    attribute INIT_1A of inst : label is "536042426CB36C4360435352685242425242426C424343535343684242424353";
    attribute INIT_1B of inst : label is "526C4268426043424252426C436042526C52605343434353436C3F1D6053436C";
    attribute INIT_1C of inst : label is "53534343436C221E60B353436C53604242426C4260C03D1F6042684260434242";
    attribute INIT_1D of inst : label is "42525268436052525343436C436053434342426C536052425242685353434343";
    attribute INIT_1E of inst : label is "6C526053434353436C53605242424242435352526C3E1F604242425268426042";
    attribute INIT_1F of inst : label is "42426C53434353434368525242426C5260B353536C53604242426C4260C04252";
    attribute INIT_20 of inst : label is "535268250060424343435368426052534343426C436053524242426C52605242";
    attribute INIT_21 of inst : label is "526042426C4260C04360426C5260435343536C5260524242424353526C434353";
    attribute INIT_22 of inst : label is "4368526042424242426C526043424343435353526C536042525252524253536C";
    attribute INIT_23 of inst : label is "604353525242426C526053434343434242424252684260424252525253535343";
    attribute INIT_24 of inst : label is "6C526042434353525242426C53604242435352525242426C5242424243536C43";
    attribute INIT_25 of inst : label is "6C5360425252525242536C5260436C200260C042604343535260524242524242";
    attribute INIT_26 of inst : label is "525353534343685360425268536042424242426C526043424343434353535352";
    attribute INIT_27 of inst : label is "434342426C52605352524242426C201D60534343434342424252684260424252";
    attribute INIT_28 of inst : label is "52426C526042435352525242426C5252424242436C426052525343436C436053";
    attribute INIT_29 of inst : label is "535353525252525242C03F026053524242524242436C53604242435343434352";
    attribute INIT_2A of inst : label is "1D43436C43605242423E0243211D536C3D0060C0424242424242434343434353";
    attribute INIT_2B of inst : label is "525252424242426C42605352422202433D1E4342426C4360525252422102433E";
    attribute INIT_2C of inst : label is "526C42605353533E0243211D524242426C53605252533D0143221D42426C4360";
    attribute INIT_2D of inst : label is "000000000000000000000000000000000000000000C03D1F60432102433E1D52";
    attribute INIT_2E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_2F of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_30 of inst : label is "42F5435352524242F9514242F54353525240435352524242C050424152524242";
    attribute INIT_31 of inst : label is "4042F7425240C0405241424142FA40425042F5524251524242C0504351424241";
    attribute INIT_32 of inst : label is "52404353524242F243524242C04043524242F75242FA425242F95240C0405253";
    attribute INIT_33 of inst : label is "42F752425240F7425240C05042425240F340F74242434242F9524043524242F9";
    attribute INIT_34 of inst : label is "C050424043524240C040425243524240F340F9534240C0505340434240FA5241";
    attribute INIT_35 of inst : label is "20004243420000F9FAFA424340F942C040524240C0504243524240FA40425240";
    attribute INIT_36 of inst : label is "43524240C05042424340434353525242424240C040001F3F1F3F00525342201F";
    attribute INIT_37 of inst : label is "B6B6B5B5B4B4B4B4B3B3B3B2B2B2B1B1B1B0B0BBBBBABAB6BAB9B9B8B4B5C050";
    attribute INIT_38 of inst : label is "24041315C0201B3700200428001315B0C07084C0BDBCBBBBBBB8B8B7B7B7B7B6";
    attribute INIT_39 of inst : label is "2606320E35152A152E0E39063E1E221D2505310F36162B142D0D38073F1F231C";
    attribute INIT_3A of inst : label is "B5E000C01001FE7100103B043C1C201F2707330D341429162F0F3A053D1D211E";
    attribute INIT_3B of inst : label is "6CC0842800C084201BC020001C01440061C04000B56000B58000B5A000B5C000";
    attribute INIT_3C of inst : label is "502800C0848468C08442B91000B942B90000B942B90014B942B9000C70B9F184";
    attribute INIT_3D of inst : label is "000000000000000000C04042201F43201F425043505240C01302687084C03700";
    attribute INIT_3E of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
    attribute INIT_3F of inst : label is "0000000000000000000000000000000000000000000000000000000000000000";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
