-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgma is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgma is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "1093025150980D8980D88FD0FD798FD0FD0905592891092141093804879290F3";
    attribute INIT_01 of inst : label is "09E5C509D5B51902E5A99580D8960A10D55DAF2F509F5E5197E0108925269081";
    attribute INIT_02 of inst : label is "EE090DF5021D196BDC9C5DA3988D8BDD0B08888D5B5D5E5C58836DE535DD537D";
    attribute INIT_03 of inst : label is "5010D43E7C0E042D305940DA0F490D05A91AD09B01ED6901DD09830D69940DC0";
    attribute INIT_04 of inst : label is "D813D14C41D091B0AA40D41DC9014C41D098040DC041D43E8841D11D42D0BC02";
    attribute INIT_05 of inst : label is "C21865202A2F820810D811DAA40DDCC357533D9509B0F4C616422E2510110812";
    attribute INIT_06 of inst : label is "2D397208D002098D002097F000098907F019849DC7022CA0C048D10F403A2A14";
    attribute INIT_07 of inst : label is "2009008D082098201900890250915096CC0042D13C34D41D198801580D10D094";
    attribute INIT_08 of inst : label is "90820190073009A497F0400982009008D002498201900890730F9A297F040098";
    attribute INIT_09 of inst : label is "50976060E67F0809E5497F0298AAAAAA6FDC70022045DC70A28DA396EDC70A28";
    attribute INIT_0A of inst : label is "BF0250985F955150901580D10D09760BF0250915096CC6C010324286080D10D1";
    attribute INIT_0B of inst : label is "F644DE931C3042D6CC6C0042DC931D1580D10D150925F9760C70E2C70C2C70A2";
    attribute INIT_0C of inst : label is "815591016860F9F900D314031D2DA390AD001039F52519856CC30F9F980D2025";
    attribute INIT_0D of inst : label is "58D2931CA49A3025F9252626401926A03939831D3931D31E31E608931E50C9C9";
    attribute INIT_0E of inst : label is "AAAAA31DA958556CC5631D4D889AA305530F9256CC304C031D4D883188898AA5";
    attribute INIT_0F of inst : label is "540D096CD43D42D09BBC40D6049DB048D44DE96F03039656CC3039555630D25A";
    attribute INIT_10 of inst : label is "8201900890254940AF5F625091529088509A085088540F9F980D13C7C041D19F";
    attribute INIT_11 of inst : label is "31D31D3931D31E49C5E0AA3931DD0F9F980D10096CE6CD02C7062401BD1ED890";
    attribute INIT_12 of inst : label is "45DC70A28DA396ED6206B0350965B555A5C70426CD09C7002ECA849CC70A4BDA";
    attribute INIT_13 of inst : label is "A396FDC70A27F039AAC96FDC706260E67F0809E5497F0298AAAAAA6FDC700220";
    attribute INIT_14 of inst : label is "DC70627F0198AAAA096EDC70427F0AAAAA096EDC70227F0F987F0AAAA8C10C5D";
    attribute INIT_15 of inst : label is "B5A58B5662056655509D5E5C5D5B5C5C708255C30B5A57F0298301919839AA6E";
    attribute INIT_16 of inst : label is "C90900980DC70A62DAAAAA096FD8508C30B5CF0C5006B0350950D509D5C5B5C5";
    attribute INIT_17 of inst : label is "06A685E750857D858D01510D80D097F0C5B625091509760C54940AF5C509B529";
    attribute INIT_18 of inst : label is "05A90509D00980D1010D4306C0C20E06905F006308B5A5E5D5C509806F0F80D6";
    attribute INIT_19 of inst : label is "08B509B53666568E5E5E5D5D5D5C5C5C5B5B5B58880E5D5C5B50902C80D02CA0";
    attribute INIT_1A of inst : label is "55D510D80D42D43D09105940D000980DF0F485C8C30B5C30C5C30D5CF0E50006";
    attribute INIT_1B of inst : label is "D6EDA396ED45D092059298AAAAAA096FD086BDC9C5DA3988D8BD41D590841D19";
    attribute INIT_1C of inst : label is "820F40880D950995B0D57BC295039C5880D958995871C880D9579958E039C52C";
    attribute INIT_1D of inst : label is "6CE02806CD098706CD0029D56039C5880D959595A500930D9509958F22029F20";
    attribute INIT_1E of inst : label is "20A6D62039C549D0948D86CD098E0096CD7FCB620A6D62039C548D4AD1900098";
    attribute INIT_1F of inst : label is "040D29AAC96FD41D7943D42D41D0965294039C5A03965AAAA096FD45550988B6";
    attribute INIT_20 of inst : label is "0A0A098A5BD4BD600020D3902A0A48D09F2EE04CD396CDF547D09A5F948D497C";
    attribute INIT_21 of inst : label is "934D0982C8FC48D494DD09A5F9103920D6C0B0F52034D13C30884ED43D49D025";
    attribute INIT_22 of inst : label is "0980DF0C5F5E5F0F6110A0A905050993C20D09070E5E58948D0920D2916D10D0";
    attribute INIT_23 of inst : label is "98A20D390260C5F00EF00005150990D55090D0703209203019F5F6808B0D4D58";
    attribute INIT_24 of inst : label is "098050990CF00E30000599C300909805050931D20D2996C303920D95092009A0";
    attribute INIT_25 of inst : label is "D2BDC526D0913D12D293620F435090408098820939009BC098E5F00E30802C30";
    attribute INIT_26 of inst : label is "48D34D4BD4AD26D33D33D20D090F6CCCB02ADC99EC2AD498049DD048D2CD4929";
    attribute INIT_27 of inst : label is "00225F92515158E9CA080D10D19E040E93C30F421DF921D48D0980A48D09F2F0";
    attribute INIT_28 of inst : label is "80D11042D397207F0F987F08AAAA8C101984DDC70A27F019849DC7022E048DC7";
    attribute INIT_29 of inst : label is "539A2C500084BD20D02A54995E98049D5048DD549C5997042DA005A90509A009";
    attribute INIT_2A of inst : label is "549C5E99045DA1CD549C539904AD0049DB2C3048D0C052500085BD20D02A5499";
    attribute INIT_2B of inst : label is "49D5000820D5BDADC5000820D4BDE049D5048D0249D1949DF90C0A549959952D";
    attribute INIT_2C of inst : label is "1D02B2C304AD8045DB2C0045D8048D13C42DE941D794AD094ED49D43DB04AD00";
    attribute INIT_2D of inst : label is "D48D42D47D41D46D49D0963030396513C41D6940A098A20D39502920D7039792";
    attribute INIT_2E of inst : label is "DC949880C5D6BDA396FD95D9BDC30506BD47D3047D49DB048E49D42D4DD42D43";
    attribute INIT_2F of inst : label is "D4DD42D4CD41D4BD49D190049D5048D13C304941DF5096CD09C0043D4ED49D6B";
    attribute INIT_30 of inst : label is "DA0F408900980D80D10D198555D02CF5096CD43D42D40D0944DE9BBC4DD47D43";
    attribute INIT_31 of inst : label is "5E0960F100491180D4DAA1984ADCBC2984AD9049D1179204AE60091100490048";
    attribute INIT_32 of inst : label is "24980980019890250915090F180D4DAA19845DC0C29845D9049DE048DF179204";
    attribute INIT_33 of inst : label is "DD42D5950396511CA006CD4DD09CA042DF949D6BD025B54980915A5097607300";
    attribute INIT_34 of inst : label is "80D6DD6CD0940F9F900DC049800898A0F9F980DD9C3079F5F649D6BD49830D94";
    attribute INIT_35 of inst : label is "D498004DD6CC2042DA00CA013C34D41D1949D4DD4AD29504DE4AD6CD093009F9";
    attribute INIT_36 of inst : label is "985098B00249452535158001989025091509DCCD204DD498C049D4DDDCCD204D";
    attribute INIT_37 of inst : label is "19A509950985098B00249652555150F00525F5158D04289820820B519A50995E";
    attribute INIT_38 of inst : label is "2549809A515097607300249809E2090DE8090D0F0252515158D04289820820B5";
    attribute INIT_39 of inst : label is "4525351573059A098001989011C00A098A21D4925D88658D9603965C002720B5";
    attribute INIT_3A of inst : label is "276073049809028908258157F02902025451535720E608B00219C50915092559";
    attribute INIT_3B of inst : label is "F9D52EDC5C6D6C58D584009A898A27D0926D0925D0924D09A23D22D21D20D090";
    attribute INIT_3C of inst : label is "191AD0919DF918D0917D0916D0915D4914D0913D1912D0911D0910D09022FD09";
    attribute INIT_3D of inst : label is "09B015098156000811899002539809150990A098A1FD091ED091DD091CD091BD";
    attribute INIT_3E of inst : label is "21181BBB901314010242724135D7205070835DF8D025050830DF3D02020D3935";
    attribute INIT_3F of inst : label is "B311114B111119BC11117B21111E3B111119511117E311112E51111F521111D4";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "90A0A08080A8083A888D6086080A6086080A085A333324545422422544455544";
    attribute INIT_01 of inst : label is "0A18185A18180A0A480A98808CAF1C009ABB81AE88AF8F80AE42FD040A0EFDC0";
    attribute INIT_02 of inst : label is "B028889920080A028F292BA0260A608D94EEEED18161A1816F10D91A0D91A0D9";
    attribute INIT_03 of inst : label is "0D98B02ABD21D02A2F0C02A21E288808AA0280AFD02ADA20280A50D8FA952992";
    attribute INIT_04 of inst : label is "B494B9640280A932A002802A9229640280A0D02C4F02A028EE02898B0289F40A";
    attribute INIT_05 of inst : label is "9F9D929F9E98956497B497BA002A99478F80D8780A01E29D98929A999E956494";
    attribute INIT_06 of inst : label is "280ADA2D12BA5AD125ABADE20A0ADC2DA20610CADB20A9A23F0CA43E20000002";
    attribute INIT_07 of inst : label is "120A0AD121ABAD120A0ADC2182A180A924FF02A9140D80280A666888480280A0";
    attribute INIT_08 of inst : label is "C2D120A0ADE23AA4ADE2EA0AD120A2AD12EAAAD120A0ADC2DE22AAAADE2EA0AD";
    attribute INIT_09 of inst : label is "80ADA2FD1CDA210A180ADA206144444402ADB23A2F04ADB2A98BA0202ADB22AD";
    attribute INIT_0A of inst : label is "C72182AA80AA8180A6888480280ADA2C72182A180A9249920000222268480288";
    attribute INIT_0B of inst : label is "6E0281A9D40D02A92499260283A00888848028780A78FADA2DB20ADB20ADB20A";
    attribute INIT_0C of inst : label is "9780A317CA3F0C0280AA91AA9CFBA0260A0A1D026A780AA89240F040280A117A";
    attribute INIT_0D of inst : label is "A4CFB00AA1600F78127A7C7C0F027E0F0C0290080200A00C00C0D0200E1F0C02";
    attribute INIT_0E of inst : label is "0000000AAA61AA924ACA95CAA0600FFAA1D1C7A9240B902A95CBCCA96A06100A";
    attribute INIT_0F of inst : label is "80288A0280280280A9E40280D0CA0F0CA0281AD820F0CFA9240F0CAAAE019700";
    attribute INIT_10 of inst : label is "D120A0ADC2182A0946A6E182A180A63A80AFFAA61A80F040280A914BD20280AE";
    attribute INIT_11 of inst : label is "00A0080200A00E9949E2A00200A0F020480A2F2202802A0ADB24A4D02002ADC2";
    attribute INIT_12 of inst : label is "04ADB2A98BA0202A982942680A687A687ADB24A0280ADB25A4444994DB2A98BA";
    attribute INIT_13 of inst : label is "A0202ADB23ADA206440202ADB23AFD1CDA210A180ADA206144444402ADB23A2F";
    attribute INIT_14 of inst : label is "ADB25ADA206144441202ADB25ADA244444E202ADB25ADA2026DA244444DA292B";
    attribute INIT_15 of inst : label is "187E31A6E0D6E68680A187A187A187ADB23A9A40D707ADA20610F0C061024402";
    attribute INIT_16 of inst : label is "922FF4270ADB2A92BA44443202AD028C421AC321A0A942680AE1180E1A187E1A";
    attribute INIT_17 of inst : label is "291909FE7649FB49FB6880288480ADC21A1A182A180ADA2182A0946A182A180A";
    attribute INIT_18 of inst : label is "0CAA080A0D4270A1D02A922992344369029F26D92578787878780A76D82982CF";
    attribute INIT_19 of inst : label is "D818061A626260D18161A18161A18161A18161AF11A181818180A9E48489E4FD";
    attribute INIT_1A of inst : label is "98880288880280280A3D0C02A2F1270A31E2D048C421AC421AC421AC321A0A6D";
    attribute INIT_1B of inst : label is "1024A0202A0480A0D0C061444444C202A61028F292BA0260A6080280A610280A";
    attribute INIT_1C of inst : label is "103E26180898F09A0D8A9340A0D028A580898009A7924580898F29A70D028898";
    attribute INIT_1D of inst : label is "0280A760280A10D02A390C8A0F028A58089A989280F220DA98309A7CA090CEA6";
    attribute INIT_1E of inst : label is "0D7E8C0F028A0C80A0C850280A7CF2202A9A47E0D7E8C0F028A0C80C80A2D225";
    attribute INIT_1F of inst : label is "204806440202A0280A0480480480AF80A0FE28A0D0CF844443202AF8F80A667E";
    attribute INIT_20 of inst : label is "AEDA1618029079095E0090A1AF1C0490A0AB020580A028E80480A98FA0580ABD";
    attribute INIT_21 of inst : label is "A0D80A9A49740580A0580A98FA1D0C00A99211EA2D0DA914FD8E05909902B0A3";
    attribute INIT_22 of inst : label is "4280A0FFAF8FAEDFCBF2FDAC0A080A9640080AAC258500A0280A0080A2082080";
    attribute INIT_23 of inst : label is "6180090A1A2F6AC32CC24A48280A888AF2888AC2AD2D720D026A6EDF9DFF8F4A";
    attribute INIT_24 of inst : label is "161485A924C32CB25A489340D5C1614A480A0080080A9A40D0C00A780AF95CA1";
    attribute INIT_25 of inst : label is "8008680080A008008AA7E03E2780A6FDA16190090A1A9341616AC32CB2A9E409";
    attribute INIT_26 of inst : label is "02A0080380380080D80080080A0B924932008CA9940086A0F0CA0F0CA0086A00";
    attribute INIT_27 of inst : label is "20A18F61A18161FA9A28880280A6104C96401E2008E200A0280AF1C0490A0A0F";
    attribute INIT_28 of inst : label is "70A9C20280ADA2DA2026DA2344444DA206105ADB21ADA20610CADB20A0F0CADB";
    attribute INIT_29 of inst : label is "89A994FDBEE0C905B0A480A485A1D0CA0F0CA480A482AED02AFD0CAA080A0D42";
    attribute INIT_2A of inst : label is "80A485A6307A9C4480A489A730AA1D0CA9240D0CAA523AFDBEE07905B0A480A4";
    attribute INIT_2B of inst : label is "0CAFDBEE05907B9F4FDBEE0590CB0D0CA0F0CA0A0C8020C4FAA52480A482A3A4";
    attribute INIT_2C of inst : label is "0B1A964010AA0107A9641107A0D0CA9140281A0280A0C80A0380580CA1F0CA2F";
    attribute INIT_2D of inst : label is "807A04807A04807A0C80AD920F0CFA9140280AEDA16180090A0F0200B0D0C020";
    attribute INIT_2E of inst : label is "8F20E30992D02AA0202A180A9B40F0902C0CA0B0CC05A0F0CA05809A05809A04";
    attribute INIT_2F of inst : label is "80AA0480AA0480AA0C80A2D0CA2F0CA9140D0C02AE88A0280AC920C808805802";
    attribute INIT_30 of inst : label is "A63E265FF4270A8880280A732109E4E88A0280280280280A0281A9C40580CA04";
    attribute INIT_31 of inst : label is "7A0A0A590AEA690A5CBA00610AA9640610AA0D0CA69EA030AA0A0A690AEA3F0C";
    attribute INIT_32 of inst : label is "A0612AD120ADC2182A180A6590A5CBA006107A9A406107A0F0CA0F0CA59EA030";
    attribute INIT_33 of inst : label is "5A0284A1D0CFA9C4D720280580A9A20280A05802A618A80612A18A80ADA2DE20";
    attribute INIT_34 of inst : label is "80A0280280A3F020480A5D0295D02A0F020480A9640F026A6E0580280610B5C0";
    attribute INIT_35 of inst : label is "80E3BF05A924DF02AD729A29140D80280A05805A0580A0305C0580280A2F62F4";
    attribute INIT_36 of inst : label is "A088AD520AEA581A581AD120ADC2182A180A924B320580619B05C05A924B3205";
    attribute INIT_37 of inst : label is "0A088A080A08EAD520AEA581A581AA22681A581AD120A0ADA2DE2080A088A08F";
    attribute INIT_38 of inst : label is "180612AA8180ADA2DE20A0612A9A2888962888A22681A681AD120A0ADA2DE208";
    attribute INIT_39 of inst : label is "181A181ADE22AA0AD120ADC29C4FDA1E380090A0099AFE30A0F0CFA0A4ADA2A8";
    attribute INIT_3A of inst : label is "ADA2DE20612A0ADC241A41ADC22A0A6181A181ADA2B72D520AAA084A180A182A";
    attribute INIT_3B of inst : label is "024A2784A4644486486DD8CA06182098A2094A209AA2098082092092092090A0";
    attribute INIT_3C of inst : label is "7A2090A209AA2090A2096A2090A209BA2090A2097A2090A2096A2090A0A278E0";
    attribute INIT_3D of inst : label is "0AE9181611AFD1CC19D6B0A180612A180AA9A1618209CA2090A2096A2090A209";
    attribute INIT_3E of inst : label is "C100051D002010111308411240CDC6FD7EE0299BB0AFD1EE0199AB0A60080A78";
    attribute INIT_3F of inst : label is "9C100009C100009C100019C100041D100040C100040C100050D100040D100040";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
