-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgmb is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgmb is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "900730F9AA98B0A0911113B911115B21111DB111111B411117B111117BB1111F";
    attribute INIT_01 of inst : label is "5830830816A25830368009834080A891C100089082019007F08098B002098201";
    attribute INIT_02 of inst : label is "A5C589590A50F920A5D5958C5D0A520D5060AA6209545D8957000891C100F202";
    attribute INIT_03 of inst : label is "589A55595459039F527262524122C190E080FD800D0EC8850A010E502009E0D5";
    attribute INIT_04 of inst : label is "01BD0E5E9E550D1950C6A79A8A509A595E98951B0191CC50D1BDA79AD009AB6C";
    attribute INIT_05 of inst : label is "A06049D9695B947654321030C0886988891400B640C6A79A8A509A595E98951B";
    attribute INIT_06 of inst : label is "1416180A0C0E0060A4E82C60A444210E50931D09F09691001298AAAAAA0949D1";
    attribute INIT_07 of inst : label is "9029F5088A5A5559595458A5139099516D81298A88A0698860F9000000842122";
    attribute INIT_08 of inst : label is "4DD090C9B5B6D67079C5C6910979D500160C4B6C509E5B509D50E5D950F95556";
    attribute INIT_09 of inst : label is "F900A80198F92A0198F9E0800000E58940C08849D87902895A95AA20CC9860C9";
    attribute INIT_0A of inst : label is "AF9A95408A520A5A964094000198F90982808A5A410F0A58A50198F9092E0198";
    attribute INIT_0B of inst : label is "A00909809882BCF98021D85009809884009821D0B7776665544322210089027D";
    attribute INIT_0C of inst : label is "9C81BD191AD098F039F9A521D95F9AA29826D3EC1550002BCF98E049F9809F98";
    attribute INIT_0D of inst : label is "AAAA940032C09AAAAAA09A5304930B910094059F9A56909A535C2909A59022D3";
    attribute INIT_0E of inst : label is "1010FFFF100010019D59833918D95329103398AF9A59595A09A59615D4914D95";
    attribute INIT_0F of inst : label is "29D239229219209094AC095CC3000C039B0293920D000220102010FF20202000";
    attribute INIT_10 of inst : label is "1DC0395BC13D1BD191AD0914D0918D0919DF915D4916D10D0917D092CD2BD2AD";
    attribute INIT_11 of inst : label is "B52CDA52BD22995239F9A9686A9686F9200940952AD8529D8AA3205BC30D9F92";
    attribute INIT_12 of inst : label is "10D6930193920D8A80E9A05958C3039F921D209B5219F9AB6A6AB6A6F9200940";
    attribute INIT_13 of inst : label is "079400909790ADB08070698A56C5BC16D7910D291AD12D091BD1913D0959C16D";
    attribute INIT_14 of inst : label is "3D1AD62D5BC12D5592FD56916D11910D1095BC12D092FDC990396516D11910D0";
    attribute INIT_15 of inst : label is "0ADE039F536C808AA098AC00398F921DB0195BC16D11910D109C02022D401BD6";
    attribute INIT_16 of inst : label is "20705644425732159C9416D0910D519894AAA892DD76543211705BC10D5D9879";
    attribute INIT_17 of inst : label is "634E264AE0240404040404F4F30404040204030302F472524000214464741457";
    attribute INIT_18 of inst : label is "D09812D000398F921DE0A0879987A98A84AE30090398F921D6CCF050293920D0";
    attribute INIT_19 of inst : label is "CC31DF93046D4ADB034D5031D5FC30A098056206CC6E0904913D13E12D098012";
    attribute INIT_1A of inst : label is "0D3950A59034D4AD3B00226DF939826D10D090AD31D19E02920D31D304AD34D6";
    attribute INIT_1B of inst : label is "48023D8922DF9B022DF023D7922D823D13D1B912D1A911D19910D1898AA23D02";
    attribute INIT_1C of inst : label is "FCDB9A4A09B95A29F8378840820D391391917909159491490915909169109090";
    attribute INIT_1D of inst : label is "97526D2ED20750700025D5930F425D3973C26D2ED0700025DA93035E7EEDCF89";
    attribute INIT_1E of inst : label is "6CC7E03E094026D907098F0F9F900D25D4CD6CC7E03E030390AD703594002306";
    attribute INIT_1F of inst : label is "80D08BC30497029A07975152ED70F4A0350F5094009A098A0000088008800000";
    attribute INIT_20 of inst : label is "2DD19D2026D26D60F426D24D1506C03920D02F52950F615B070980F50950F9F9";
    attribute INIT_21 of inst : label is "5A75F92DD194FDA02DE83025FC00050994020D092CD2CD2BD2BD2AD2AD29D29D";
    attribute INIT_22 of inst : label is "90AD81C06E300065A75F9100AD802DE2688C25DF920F91984521D352ED06E306";
    attribute INIT_23 of inst : label is "60302DD194FD20D7920D802DEFC06CC3E09401104525D3521D2DD19AA4FD2EDF";
    attribute INIT_24 of inst : label is "982DD91C2DD6022DA02DE20E9F58031D90C2DD0980C570F46CC3E09401102ED0";
    attribute INIT_25 of inst : label is "6CC1AD091BD1920D092DD1921D695022D21D29FAC12DAAAF9813D198AAAA098C";
    attribute INIT_26 of inst : label is "9825D9AC302DE9AC25D25D9047D46D34DFC06CC20D39502DEA079F525D0990F4";
    attribute INIT_27 of inst : label is "3E09401100502DD4FD902DEFC06CC3E09401102ED06E300065F92DD194FD25D1";
    attribute INIT_28 of inst : label is "09401102ED060602DD194FD002DEFC06CC3E094026D6CC20D3980892DD2DE6CC";
    attribute INIT_29 of inst : label is "90024D6CC3E094026DBB023D0922D290022DE0C94DD25E300925D25EFC06CC3E";
    attribute INIT_2A of inst : label is "DA1C2DD8926DF92ED8198F97970790ADA9CF930F90ADC0D94DD2EDBB023D24D0";
    attribute INIT_2B of inst : label is "9009823D24D09905924D24EC02DE23DF92009A05984DD23D0922D19802DE0022";
    attribute INIT_2C of inst : label is "A75F96CC3E094022D09180B522D2EDBB022DBB92DDBA98AF923D23DF920F9198";
    attribute INIT_2D of inst : label is "9181719282A3938373636454544444343424241414151516161717006E300065";
    attribute INIT_2E of inst : label is "E094026DF924D826DBBC1106020D002DE20D20D1925DF9D03540C5E1D1C1B1A1";
    attribute INIT_2F of inst : label is "BACB0392094099F92198CBC14D097094C00988948AE020DCF0D523DC522D6CC3";
    attribute INIT_30 of inst : label is "D20D0960C100D546DC545DB00547D20DF920DBFC23DD50922DC582924DC182DD";
    attribute INIT_31 of inst : label is "C5D0C5C46DD51945DC56910C100C6C2ED15D4047C20D20D1925EB00925D25E20";
    attribute INIT_32 of inst : label is "8292DDC11015D2ED06F9E30006514DF9C5CD5D509C5C5829E014DC4C46DD545D";
    attribute INIT_33 of inst : label is "8A099F920921900FC0047CB004809889099F9219209500000B9C23DD50922DC5";
    attribute INIT_34 of inst : label is "D9823DAE09523D6CC3E09401102ED06F9E300065F92DD194FD802DEFECD08098";
    attribute INIT_35 of inst : label is "965502DEDEC303920D0035FEC10193920DC0C595698192039656CC13D1E912D1";
    attribute INIT_36 of inst : label is "30D0923E10D5D98790AD11D09651C9823DA6CC6E0609523D2DD65598DDC49503";
    attribute INIT_37 of inst : label is "DE6CCD6030D09F080988E300650D9F92199019202939209B049F921940048809";
    attribute INIT_38 of inst : label is "92DD19A4FD302DEFEC20D1950A031D349A34C34E6CC3E09401100502DD4FD902";
    attribute INIT_39 of inst : label is "50A031D349A34C34E6CC3E094090961109525D25D300919825DD0F505065A75F";
    attribute INIT_3A of inst : label is "910098880F90822D092DD09FCC2EDF90AD80F90AD202DE25D098022DFEC20D19";
    attribute INIT_3B of inst : label is "F9FFC26DF919826DE02DE40F908F5C26D7506E3065A75F96CC2DDA4FD25D22D0";
    attribute INIT_3C of inst : label is "029F58C022D3E09401102ED26DF97506E3065A75F925D300919825D3019F52DD";
    attribute INIT_3D of inst : label is "35C56CC080820E99580D9A0F9E089C0596039F9219F0293920980046CC109795";
    attribute INIT_3E of inst : label is "9902DD10D11916D1098A82DE30290397079F5C0890398F921D90193920D2020D";
    attribute INIT_3F of inst : label is "19825D2EDF909806E3065A75F9003039F520D09886CC29030892DD8802DD20D0";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "A6ADE22AA5AD52A0A100019C100009D100009C100009D100009C100019C10000";
    attribute INIT_01 of inst : label is "E3012FD806606109040A0A00A6FDCC494B0A6DC2D120A0ADA230AD520A0AD120";
    attribute INIT_02 of inst : label is "4A4E34AF14A6FA114E4A4E34A134A134A6EDC4E094803614AFD1CC494B0A0A60";
    attribute INIT_03 of inst : label is "80A487A487AED026AA6A6A6A6A7A3AFAE64ADB4AEBAC4EE0B460D5A0A60AE34E";
    attribute INIT_04 of inst : label is "2A6B658F25A208AAED4CA028E48064A484614AA52AAA34208A6BA0280D1284A4";
    attribute INIT_05 of inst : label is "C21F02B1A180AEEEEEEEE6FD4C6A06194490A64EED4CA028E48064A484614AA5";
    attribute INIT_06 of inst : label is "0D08030E09040044332221110000006580A0080AD11C490AAABA444444C202BA";
    attribute INIT_07 of inst : label is "FD026A6A648467A48467A148AB70A48AA71ABBA049FD0E3C0F320A8421000002";
    attribute INIT_08 of inst : label is "05A6D90C1A1E1EED021A1E49E0021A0AAD21A1A180A18180A186580A0D02AAAE";
    attribute INIT_09 of inst : label is "F4118A6061F4A72061F401966666580AFD0EEC029B1B0AA1601800A440E3090C";
    attribute INIT_0A of inst : label is "A0221AFD81E091C2120A180A6061F41E3AA29181A192F1C9186061F424A82061";
    attribute INIT_0B of inst : label is "EDCCC2A4619AE4129600990FC2A4E391F22A00B06000000000000000060A6ACB";
    attribute INIT_0C of inst : label is "5462097A2090A40F0C021800B18024406100BA147A0D0EAE4129DD0C02A60129";
    attribute INIT_0D of inst : label is "0000180AA8440444444C21A1D0C1F0C2D5A0D0C021800F21AA5400F21A0D00BA";
    attribute INIT_0E of inst : label is "0800FFFF0000006209A61ABB20910ABB13ABBA0021A18104C21A10209AA20910";
    attribute INIT_0F of inst : label is "0092092092092090AA340AA540F0E0F0C590C0200B0A0A00080000FF00000008";
    attribute INIT_10 of inst : label is "0B0F02A642092097A2090A2090A2090A209AA209AA2092090A2096A009009009";
    attribute INIT_11 of inst : label is "0800B0800B2090A209122020020200FA0F0A030800B0800BA48A12A640D0C020";
    attribute INIT_12 of inst : label is "209EA3D0C0200BA0390C1F0CA340D0C0200B2090A209122020020200FA0F0A03";
    attribute INIT_13 of inst : label is "DCA0DCCC00260A2D0CFF1CA0A94A642098A209EA2092090A2097A2097AA24209";
    attribute INIT_14 of inst : label is "6A20956AA64209ADB009ADB20900B20900BA642092A0090A1D0CFA20900B2090";
    attribute INIT_15 of inst : label is "60AED026AAD41FA4A161801B1BA0200B0F0CA6420900B20900B0A0F00B0A2095";
    attribute INIT_16 of inst : label is "E0C0EAAEECCEEEEA241A2090A209ABBA184441200BEEEEEEEEE6A64209A8BA02";
    attribute INIT_17 of inst : label is "8008880380A00000000000303060000000600060207ECACEE000EEEEEEC8EAE8";
    attribute INIT_18 of inst : label is "916120B23B1BA0200BDF864A2B4A2BA0903E0D22B1BA0200BA541F090C0200B4";
    attribute INIT_19 of inst : label is "84008FA1D03003A1F00A1D00AAF40BA1614AAC2A54AF2097C20B20F2090A1120";
    attribute INIT_1A of inst : label is "080A0DBA0D00003AA120A0083206100A208E060A0080A2D0C00A0080D03000AA";
    attribute INIT_1B of inst : label is "A760090A009FA0300B0D00902007100B209B8B209B8B209B8B209B8BA0000B60";
    attribute INIT_1C of inst : label is "7AEA8A4A2A9AEA0A0AEA4A6650090A2097A2096A209AA2090A2096A2092090A4";
    attribute INIT_1D of inst : label is "CFA00800A234AB825A0080A31E20080AA8400800AB825A0080A1F7AA1A6A4A7A";
    attribute INIT_1E of inst : label is "A54AD2CD2CB200803ACBA0F040280A00805AA54AD2CD20F0260A0D7ACB20A1B0";
    attribute INIT_1F of inst : label is "80A6A140B0C090C2F0CFA7800A11E21D7A6480A4D5CA16188888830082128318";
    attribute INIT_20 of inst : label is "0090AB2200900A01E20090087A48AF0200B1A480AE14C78E3ACBA6480A0D0402";
    attribute INIT_21 of inst : label is "8448FA0090003A2100DA3F8AA726480ACB20090A00900A00900A00900A00900A";
    attribute INIT_22 of inst : label is "260AAC44AC020A48448FA1160A2100D88AD40090A0D020618A0098A0094AC024";
    attribute INIT_23 of inst : label is "AB220090003A009F200B1D00DA72A54CD2CB2B328800B8800B009000003A0093";
    attribute INIT_24 of inst : label is "6100BA4400B0F00B2300D5D026A5D00AA340092A0F6A23E2A54CD2CB2B320094";
    attribute INIT_25 of inst : label is "A542090A2097A0090A0090A0090A0F00B0090AAC4209000029209761444432A0";
    attribute INIT_26 of inst : label is "E300AAD40300DAD400900A0D05005000AA72A540090A0100D0D026A0090AF3E2";
    attribute INIT_27 of inst : label is "CD2CB2B32BC200903A0100DA72A54CD2CB2B320094AC020A48FA0090003A0090";
    attribute INIT_28 of inst : label is "2CB2B320094AB520090003A1D00DA72A54CD2CB200BA540090A091C00B00FA54";
    attribute INIT_29 of inst : label is "A4100BA54CD2CB2009A320090A0090A1100B1B1C05A00D091C00B00FA72A54CD";
    attribute INIT_2A of inst : label is "BA740090A009320071061F402018260AAA402118260A092C05A009A320090090";
    attribute INIT_2B of inst : label is "0926100B0090A190C00B00F3100D0091A092C432E305A0090A0090AA100D2100";
    attribute INIT_2C of inst : label is "448FAA54CD2CB20090AB321800B009A32009A4B009A4BA01200B0091A0D12061";
    attribute INIT_2D of inst : label is "00000000000000000000000000000000000000000000000000000064AC020A48";
    attribute INIT_2E of inst : label is "D2CB200932007100BAB4B320100B2F00D0090010A0090A0F7A0D6A0000000000";
    attribute INIT_2F of inst : label is "AD4DF0200BED0C0200BAA140380A3D1E0D161918A85100BAC24800B4800BA54C";
    attribute INIT_30 of inst : label is "90018AC14B0A4802A4802A3F4C02A0097200BAA4009460A0094610A0094BC009";
    attribute INIT_31 of inst : label is "4A03A6402848BA02848CA1D4B0AAB400903A4F02E0090010A00D0D1C00B00F00";
    attribute INIT_32 of inst : label is "10A0094B0A0380094A32C020A480387AA6448460A484610AEF03AA340284A028";
    attribute INIT_33 of inst : label is "90F0C0200100B5AA726028E94CA16190F0C0200100B1F5E5AAA4009460A00946";
    attribute INIT_34 of inst : label is "ABA00705B1C00BA54CD2CB2B320094A32C020A487A0090003A1100DAD4EDA161";
    attribute INIT_35 of inst : label is "CFAB100DAF40D0200BFD7AAD41F0C0200B0F6A180610A0D0CFAA54209BAB209B";
    attribute INIT_36 of inst : label is "0088A00F209A8BA0260A2096A48BABA0070A54AF2091C00B009FE0A3A840A0D0";
    attribute INIT_37 of inst : label is "0DA54B420080ACDA1616C024A0F0C0200B0D0C1B0C0200B1F0C0200B2F4C4A0A";
    attribute INIT_38 of inst : label is "A00900403A1100DAD40090A010F00A009800A00EA54CD2CB2B32BC200903A010";
    attribute INIT_39 of inst : label is "010F00A009800A00EA54CD2CB2F11CB321800B0090B1C06100B0D6ABD248448F";
    attribute INIT_3A of inst : label is "AF916191BA42A0095A0093AA240093260A0D3260A1300D0090A5D00BAD40090A";
    attribute INIT_3B of inst : label is "FAA240093206100B0300DD9A42AA340094A4AC0248448FAA54009003A0090090";
    attribute INIT_3C of inst : label is "D026AA0F00BCD2CB2B32009009324A4AC0248448FA0090B1C06100B2D026A009";
    attribute INIT_3D of inst : label is "706AA5463610B1C7A0D0C0F0C0F0C0F0C1F0C0200B1B0C0200B2F4CA54209EA0";
    attribute INIT_3E of inst : label is "A0100B20900B20900BA0900D0D02B1B2D026A3D02B1BA0200B3D0C0200B5D000";
    attribute INIT_3F of inst : label is "06100B009322614AC0248448FA0A2D026A0090A66A54AD20B0C00B6660090090";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
