-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgmc is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgmc is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "B9F921940293920980880965A75F9AA00618B490104066CC3E094011025D3009";
    attribute INIT_01 of inst : label is "88E300650B94019F921920293920960880965A75F9075900988E30065039A5B0";
    attribute INIT_02 of inst : label is "ED06A075908098C5E3006500903DAF9219D0F46029209C40065F975F9075B009";
    attribute INIT_03 of inst : label is "102EDF909826D06107506C08098C5E300650F90C40006E30060065A75F901102";
    attribute INIT_04 of inst : label is "026D82EDB51944D006F929024AA092CD80925A092AD80901102ED1200602ED01";
    attribute INIT_05 of inst : label is "5826DC5B540B5C517C0986019198F917CC5809C50826DF926D8B520B51019F06";
    attribute INIT_06 of inst : label is "0F10D2092073053044032F072F0121053404390241064A03570468070826DF9C";
    attribute INIT_07 of inst : label is "2995B0E546C30F404F88C020EF0FC80F204F04E0204F05250AE505250A0E1011";
    attribute INIT_08 of inst : label is "D529C5692A2D2A2D2A222A270828D829DAA753509040A098A20D3902E0197550";
    attribute INIT_09 of inst : label is "6925C2CD2AD2BD29D0902D539C5692EC0C0A529950925C2CD892AD2BD29D0902";
    attribute INIT_0A of inst : label is "20D0225C2AD892CD2BD29D0902D539C56925C2CD0933D2AD2BD29D0902D539C5";
    attribute INIT_0B of inst : label is "00000000B030800000000000B0042D0943D290108975769509F0A098A0103939";
    attribute INIT_0C of inst : label is "0000100000201008000010000030600000000000B030800000000000B0300000";
    attribute INIT_0D of inst : label is "0000100070401C0C000010007030100800001000203014000000100020201404";
    attribute INIT_0E of inst : label is "0000000030300000000000003030400000000000303080000000000030401C00";
    attribute INIT_0F of inst : label is "000000002030480000000000D03048080000000030308800000000003030C008";
    attribute INIT_10 of inst : label is "D90A48D809F2B0E5010C53531D304808000000007030400800000000D0304008";
    attribute INIT_11 of inst : label is "CA09AAAA41D8B911D74D72208048E01011E042C304AD9046D42C6046D8048D46";
    attribute INIT_12 of inst : label is "D0604DD34D84AD04DE30B94DD44E308944D44E90F9F5010F99542C3034D4AD6B";
    attribute INIT_13 of inst : label is "4DD204AD70F44DE9533D33DB531D09E5D9B50950D097C05EC6FC64C304AD6FC4";
    attribute INIT_14 of inst : label is "3DC536D42DB535D41D2035D41D36D42D37D43D8E5E95509A95A9519870AA0AD0";
    attribute INIT_15 of inst : label is "56C35DB536DC537DD580B535DC536DD5837D40B08888B519B5C50988C5D537D4";
    attribute INIT_16 of inst : label is "D3902A6A648D1914D5039394DD4CE30894CD4CED07910194DDD6049D4DD4BDA5";
    attribute INIT_17 of inst : label is "F98FDA95A95954987970C98954DD041DB944D48D30A919848D11D1940A098A20";
    attribute INIT_18 of inst : label is "D0886DC8400909A093D309446E0248C004CD11D81D4DD80D44DAAAA8FD4FD19A";
    attribute INIT_19 of inst : label is "956DCAA95A9560C840090993D46D46D8489953029D06595C0D0F993D8AAAA93D";
    attribute INIT_1A of inst : label is "9504ED956034DE009A09A8C0393920D0211D4CD4011E04DD19504AEA04AD66CA";
    attribute INIT_1B of inst : label is "0C9F90AD7BC16D60B941DC048D04ED9520939D059F921987009090AD50F94ED8";
    attribute INIT_1C of inst : label is "9D7798AA82DD1926D7898B0B5F031DC9830C9F90ADB6B540B931DB5097BC16D7";
    attribute INIT_1D of inst : label is "995AF90AD25944D7CC969223D1922D6925944D7048D8A2CD7A92BD7992AD7892";
    attribute INIT_1E of inst : label is "9020909219950921948EB048D259A44D22909305995A047DF046D46DD04AD40E";
    attribute INIT_1F of inst : label is "000804000C0404040C00000800A0A49D09B234567890B72E95B72E95047D46D0";
    attribute INIT_20 of inst : label is "000008EE8EE8EE8EEAA4E82C28E4AEEE8EEEEE8EE0080C00040C0C0C04000008";
    attribute INIT_21 of inst : label is "8EEEEE8880000000000002222AAAAA4E88E8E8E8E8E8EEEEEEEEEEEEE0000000";
    attribute INIT_22 of inst : label is "8F97F00096F95F94F8DEF0AB2000000000000EEE2EEEEE2EE2222EEEEE222888";
    attribute INIT_23 of inst : label is "4A74A74A70004A74A74A70004A74A74A70004A74A75A70006AF7AF8AF00099F9";
    attribute INIT_24 of inst : label is "70005B7FB7FB7000FA7FA7FA7000FA7FA7FA70004A74A74A70004A74A74A7000";
    attribute INIT_25 of inst : label is "555015551555155501555155515550007B77B77B70007B77B77B7000FA7FA7FA";
    attribute INIT_26 of inst : label is "145551255511555014555125551155503A2A1A012555115551B0145551255511";
    attribute INIT_27 of inst : label is "4855524555125550445552255512555018555145551255501855514555125550";
    attribute INIT_28 of inst : label is "34AAA34AA834AA6034AA634AA434AA2024555245552255504855524555125550";
    attribute INIT_29 of inst : label is "000000000007000000000000004D00000000EB00000000410000000000000000";
    attribute INIT_2A of inst : label is "0000006100000000000000000000C9000000A500000000000000000089000000";
    attribute INIT_2B of inst : label is "000000650000000000C90000000000000000CF00000000000000000F00000000";
    attribute INIT_2C of inst : label is "4000FF2F00F120000000000000006100C965000000000000000000002B000000";
    attribute INIT_2D of inst : label is "1080108F1080108F1080108F003006007F463F4B3F4F304F007E413E403E493E";
    attribute INIT_2E of inst : label is "00108018081800100000EF8D408F208F00308030803080308030803080208000";
    attribute INIT_2F of inst : label is "204F204F25454040204F204F254500A040A0400010804F8E400E120C00080018";
    attribute INIT_30 of inst : label is "AF9F00209020902090209020902090209020902090209000104800104F004040";
    attribute INIT_31 of inst : label is "140F100F180F101010001220001020009F0F904FA04F00C4C09148A04800A197";
    attribute INIT_32 of inst : label is "304F002E4D10403E4710403E4110403E4B604000101010E8000F182F1B4F1E8F";
    attribute INIT_33 of inst : label is "2E1F006010301000610AA1000000FA002E4210433F4610473F4A104B3F4E304F";
    attribute INIT_34 of inst : label is "F9E0F920F960F9A0F9E0F920F960F9000F0F4403007000AE033006003F221010";
    attribute INIT_35 of inst : label is "D690A835F9D5D519D536E0A29F28E4D620F4F920F960F9A0F9E0F920F960F9A0";
    attribute INIT_36 of inst : label is "A0D5CD9D5CF9D5CC9DCCBD9D5BF9D5BC9008AD5D6D680D660D6A034E0D5F20E4";
    attribute INIT_37 of inst : label is "8D6080D5D5D509D5890AAD5D58D4CE9D5CD9D4CBE9D5BD9B08AD8CB0D540D5D5";
    attribute INIT_38 of inst : label is "44E442088E0208D0930AD5D580D00D09728FD0FD798FD0FD090D5C30A00DE7C7";
    attribute INIT_39 of inst : label is "A890D51902C044E0243C8421B840FB04EDC42CCEC0CC20ECD48CEF58C0150C23";
    attribute INIT_3A of inst : label is "07035552589C509820C509A515B50703565851595070355525E565EAD855EAD8";
    attribute INIT_3B of inst : label is "55535EADA75C5095590DE555254515890D0C9A5988820A515B50703565851595";
    attribute INIT_3C of inst : label is "CD85159507035EAD50C959875C5098B00219820A515B507035EAD88515950702";
    attribute INIT_3D of inst : label is "20E050704090B0A0C00690690690690B089E5855D6890C509820A515B507035E";
    attribute INIT_3E of inst : label is "00200026002C00120018001E0004000A00C0004000607050C0B09020E0E08020";
    attribute INIT_3F of inst : label is "062000260A2C04120E18081E02040C0A06500056004C00420048003E0034003A";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "0C0200B1B0C0200B1F4A0A48448FA66807D5E19D66121A54CD2CB2B320090B1C";
    attribute INIT_01 of inst : label is "16C024A0D0C0F0C0200B1B0C0200B1F4A0A48448FA64AD91616C024A0F029A0D";
    attribute INIT_02 of inst : label is "094A434ADDA1611AC024A0F12B1BA0200B03E21D0200B185A487A48FA64AD916";
    attribute INIT_03 of inst : label is "320093216100B4A114A4AEDA1611AC024A09A42185A4AC024A0A48448FA6B320";
    attribute INIT_04 of inst : label is "F00F300B180004A64A32A624AA68C00F30A4868C00F30A6B32009B124A60096B";
    attribute INIT_05 of inst : label is "E300B181A091C18B442E3092C061F4B641E34A186A0093200711A091C1B2C131";
    attribute INIT_06 of inst : label is "20740700740700740700706E736E776E726E756E716E746E706E706E6A009321";
    attribute INIT_07 of inst : label is "0C7A2D5AB2403E201F00F1021F00F000011F01F2021F000000F00000000E7017";
    attribute INIT_08 of inst : label is "48BA48EABBB9BBB7BBB6BBB364B2B4B2BA0FA780A6FDA16180090A1A0D02FA1B";
    attribute INIT_09 of inst : label is "8AB540080080080080A6A48BA482ABC4A52480A485AB540082A0080080080A4A";
    attribute INIT_0A of inst : label is "00B5AB540081A0080080080A4A48BA48EAB540084A0080080080080A6A48BA48";
    attribute INIT_0B of inst : label is "0000000000001F00000000000060280A0280A60B0CFAFE780AEDA161860F0C02";
    attribute INIT_0C of inst : label is "00000000000005020000000000000C000000000000000D000000000000001E00";
    attribute INIT_0D of inst : label is "0000000000000E090000000000000B0D0000000000000C050000000000000106";
    attribute INIT_0E of inst : label is "0000000000001C040000000000001E010000000000001100000000000000030B";
    attribute INIT_0F of inst : label is "000000000000010A0000000000000C0B0000000000000D0F0000000000000E02";
    attribute INIT_10 of inst : label is "8F1C04710A0AFD5A60F607000A000D090000000000000E0A0000000000000309";
    attribute INIT_11 of inst : label is "4A56000005E30A028BDB0A090E05A60302C6BD40D03A0D03ABB43F03A0D02A03";
    attribute INIT_12 of inst : label is "820903C006103A603E0B0C03A04C090C04A04EFD126A60F027ABD40D00003ABE";
    attribute INIT_13 of inst : label is "05ADD05AD3E205E780D8008480080A580A480A208AABD2B84B94B940F03AB94B";
    attribute INIT_14 of inst : label is "4A180D904A180D904A590DF04A0DF04A0DF04A3580AA80AA160180E3CB4CB4CF";
    attribute INIT_15 of inst : label is "B440D91A0D91A0D91ADB1E0DB1E0DB1E30DB2B4EEEED18061A18561F1A180D90";
    attribute INIT_16 of inst : label is "90A1A9E900280A0383D040205A05C090C05A05E0D02192C05AB5205805A0589A";
    attribute INIT_17 of inst : label is "02BABA1601A1836102033E31805A60580A0480580B0C06105A0280AFDA161800";
    attribute INIT_18 of inst : label is "ED8EB24E0BECF20FB6B1F1A0380A0280A038028BBB038BBB0484444BAB038000";
    attribute INIT_19 of inst : label is "1AB54441601AB44E1BECF2B6B03803610491A2F0C1FFA180B0C02B6BA4444B6B";
    attribute INIT_1A of inst : label is "7A60387A0F00AED0CA16813F0C0200B5A02803A2D02C60480A0D05C0F05AB740";
    attribute INIT_1B of inst : label is "B0C0260AB2403A0F0C05A1F02A60387A0090AEF0C0200BAF95CF260AF90C03E3";
    attribute INIT_1C of inst : label is "09BEBA0090090A009BCBAEF1CEF0DC0E3090C0260A1E180F0C0DA180AB24038F";
    attribute INIT_1D of inst : label is "C18A0260A00904ABA4180A009BA009CA00904A1F02AA8009BEB009BEB009BEB0";
    attribute INIT_1E of inst : label is "A60090A00910F200B04DCF04B009404A0090A290C7A2F05C2F05C03A0D03A290";
    attribute INIT_1F of inst : label is "0B020C050E0601060305050206F1C0290A0A0000000111100033322260580580";
    attribute INIT_20 of inst : label is "0000095595595595566655545556655555555555550D030B01090E090C0B0B0D";
    attribute INIT_21 of inst : label is "9999999990000000000009999AAAAAA999595959595959595959595950000000";
    attribute INIT_22 of inst : label is "02101000101101100A3E53AB0000000000000999599999599999999999999999";
    attribute INIT_23 of inst : label is "1041041040001041041040001041041040001041031030001031031030001021";
    attribute INIT_24 of inst : label is "5000005005005000005005005000005005005000105105105000105105105000";
    attribute INIT_25 of inst : label is "0720E072E072E0720E072E072E07200000700600500000600500500000500500";
    attribute INIT_26 of inst : label is "FD072FD072FD0720FD072FD072FD0720F0F0F00ED072ED072ED0ED072ED072ED";
    attribute INIT_27 of inst : label is "FD072FD072FD0720FD072FD072FD0720FD072FD072FD0720FD072FD072FD0720";
    attribute INIT_28 of inst : label is "FD270FD270FD2700FD270FD270FD2700FD072FD072FD0720FD072FD072FD0720";
    attribute INIT_29 of inst : label is "00000000001000000000000000FE000000006600000000000000000000000090";
    attribute INIT_2A of inst : label is "0000008700000000000000000000110000005500000000000000000032000000";
    attribute INIT_2B of inst : label is "000000CB0000000000990000000000000000430000000000000000B900000000";
    attribute INIT_2C of inst : label is "00000F0200000000000000000000EE00DDCB0000000000000000000098000000";
    attribute INIT_2D of inst : label is "001A001A001A001A001A001A000030000F0A0F080F0A00080000050000000700";
    attribute INIT_2E of inst : label is "160F1601140F150016000F0A000A000200010601050104010301020101000000";
    attribute INIT_2F of inst : label is "000C0000000C00000000000C000000010001000000100F38001800280010160F";
    attribute INIT_30 of inst : label is "0F0A00010D0F0F010D0F0F010D0F0F010D0F0F010D0F0F00040A000000000000";
    attribute INIT_31 of inst : label is "022F033F044F06000600100C00100B000F16000600000000010000020000000A";
    attribute INIT_32 of inst : label is "000400000B000000080000000500000001000000000A00DA001F011F011F011F";
    attribute INIT_33 of inst : label is "0F0A000107000200001400240010F0000F0A00040F0A00040F0A00040F0A0008";
    attribute INIT_34 of inst : label is "7A1D6A2D5A2D1A2D4A2D3A3D9A3D0A001F1A001A00001D00140013000F0A000A";
    attribute INIT_35 of inst : label is "EAE1C8F8FAD9C90AA9F80FB4B0AAE8E823E2EA0D8A0DDA0D2A0DCA1DBA1DAA1D";
    attribute INIT_36 of inst : label is "0DC9B2BD9B2BB9B2BBB4B2BD9B2BB9B2B1BA0ABAFAF3DDD7DCD7FFE7FAB0A6EA";
    attribute INIT_37 of inst : label is "F9090EBBB9B5F2B590948B9B71BBB2BC9B2BBE4B2BC9B2B0BA0BF4CDA90FBBA9";
    attribute INIT_38 of inst : label is "0CF00066080A6080AF1CB9A96096090A0A6086080A6086080A6B8403C609B046";
    attribute INIT_39 of inst : label is "8DC2680A0AC000FD000FD000FD00FFE0FFFE0FFFE0FF0FFFF0FFFF0FF0000F00";
    attribute INIT_3A of inst : label is "A62081A085A08AADE2080A080A08A62081A080A08A62081A084A18B3BE18B3B4";
    attribute INIT_3B of inst : label is "80A08B3BA08080A088884A781A781ADC2993CA0616DE2080A08A62081A080A08";
    attribute INIT_3C of inst : label is "3A080A08A6208B3AC93C0610A08AAD520AAADE2080A08A6208B3BE080A08A620";
    attribute INIT_3D of inst : label is "5810283010101800082100322100326895C4610A6EDC2080ADE2080A08A6208B";
    attribute INIT_3E of inst : label is "000D00070001000C00060000000B000500D05060C84058A03040883038602030";
    attribute INIT_3F of inst : label is "030D03070201020C01060100010B0005000A0004000E00090003000D00080002";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
