-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgmd is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgmd is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "022000260E2C0C120A18081E0604040A025000560A4C04420E48083E02340C3A";
    attribute INIT_01 of inst : label is "0820002C081800140810000C08080004085010561E4C0C420A48083E0634043A";
    attribute INIT_02 of inst : label is "1420102C0C1808140410000C0C0808040450104C184810441830103C18380024";
    attribute INIT_03 of inst : label is "1A20102216140C160218080A0E0C040E0A50204C2C4818441430103C1C381824";
    attribute INIT_04 of inst : label is "102010181010101800100008000000080040204226442C362238183A1E3C142E";
    attribute INIT_05 of inst : label is "2C201018141018181C100008040008080C403048203020382030203820201028";
    attribute INIT_06 of inst : label is "2220201E1E1C1C1A1A1818060604040202403048343038383C30203824202828";
    attribute INIT_07 of inst : label is "281020141818101C180010040808000C0840403E3E3C3C3A3A38382626242422";
    attribute INIT_08 of inst : label is "28102010181010001800100008000000083040344838303C382030243828202C";
    attribute INIT_09 of inst : label is "2E102016220C14021608180E0A040C0A0E304020482030203820302038102010";
    attribute INIT_0A of inst : label is "2410200C2C0818041400100C0C08080404204026422C44223618381E3A143C1A";
    attribute INIT_0B of inst : label is "240020082C001808140010080C0008080420502C4C1848144410301C3C183814";
    attribute INIT_0C of inst : label is "3A00200E260C2C0A120818061E0404020A1050184C104818441030183C003808";
    attribute INIT_0D of inst : label is "3A00200A26042C0E120818021E0C04060A10501E560C4C0A420848063E043402";
    attribute INIT_0E of inst : label is "3A00200026002C00120018001E0004000A00500A56044C0E420848023E0C3406";
    attribute INIT_0F of inst : label is "62C30090398F921D0629026D3BC24D600600500056004C00420048003E003400";
    attribute INIT_10 of inst : label is "F9862C30004DC3009098F049912C31D12D60064C05A06BC30350660C5A03920D";
    attribute INIT_11 of inst : label is "6912CD2057C300909855C3069F921D0662C065049198F95000FFDC5FEDB5A958";
    attribute INIT_12 of inst : label is "6A96AA5B595958950952912CB020455000B5C595B5B5AA595A956BC94026D065";
    attribute INIT_13 of inst : label is "5B509509C5C5A5B5B595896A612C40204544C60B045A0B0250000C5B5B595B59";
    attribute INIT_14 of inst : label is "009509C5A5B59512C8020252080B5A5959520B5C5B595B59500B696B696B5C59";
    attribute INIT_15 of inst : label is "D9529D5CCC5B5F90954950C5C5A5B5B5958A69612C30204556C90B04570B0251";
    attribute INIT_16 of inst : label is "921D0612C0C620B6B5F9B5C5F90045C52CDB52BDA6209695F995A5F90025A52A";
    attribute INIT_17 of inst : label is "921D26DF995809957019826D8F296BC064990912C9100191A049D12ED60F069F";
    attribute INIT_18 of inst : label is "826DF006530D579B52CD952AD4079F921D90000108920D06D20940250926D70F";
    attribute INIT_19 of inst : label is "CD952ADD5790039F921D6EC30A0102920D7000D2026D80670094026D0656912C";
    attribute INIT_1A of inst : label is "9502CD65C9529D092AD820202ADE07009198F9502AD0405F0D5097DC30530B52";
    attribute INIT_1B of inst : label is "0A9D09910895049AF921D8A90C595092BD092CD820202CDE0020D3907009198F";
    attribute INIT_1C of inst : label is "D33ED099F921D303920DA0898201980398F921D69C3000020D39A848E2220699";
    attribute INIT_1D of inst : label is "3032D528DC527D9606B094026DF90983019826D8950100B5A509951996305933";
    attribute INIT_1E of inst : label is "902ADC52AD29DB529D8760501902CDE52CD2BDD52BD87D0501926D9680A8B5C1";
    attribute INIT_1F of inst : label is "DA592DAA399621D950902ADC52AD29DB529D874002CDE52CD2BDD52BD87B0501";
    attribute INIT_20 of inst : label is "AD091BD1916D10D0911D09968A5886CA5A5892DB08833E304033CA8DE08AB593";
    attribute INIT_21 of inst : label is "1D41D47D42D42D48D43D43D8849D50F4C029816D10D0911D094ED958968DCB51";
    attribute INIT_22 of inst : label is "398091549895C509DE0000398F921D96AB0B593DA5892D9509AA8DCAB0000984";
    attribute INIT_23 of inst : label is "D292019AB00950B0D080820D2913D0912D0915D84914D83988A98AAAA969D025";
    attribute INIT_24 of inst : label is "AAAAB59B0F9A59B0AAAAA57F0C68308F9950DA0815D65D14D64D22D1923D0920";
    attribute INIT_25 of inst : label is "5101510150005002CDB52BDA52AD9529D85067FC810C47FCC650807F08B57F08";
    attribute INIT_26 of inst : label is "B035F0F430000008570757075606560655055505540454045303530352025202";
    attribute INIT_27 of inst : label is "9D5C5AAAA25DD5D50994CD5098801994CD5D5809A0190019D526D26D8949826D";
    attribute INIT_28 of inst : label is "088045C841D0941D8042D42D843D43D8870F404028DB5F927DC58E9B5C6AC6AF";
    attribute INIT_29 of inst : label is "0CB045D40DACC4AD40D9049DE048D40EF06940D888A47C4047C889045D8841D0";
    attribute INIT_2A of inst : label is "D42D47D41D46D48D43D47D42D46D41DA3C4DD43D4CD42D4BD41D5049D0A888DA";
    attribute INIT_2B of inst : label is "565155543D4DD42D4CD41D4BDB3011A722030C7049DC0F442001535254543D48";
    attribute INIT_2C of inst : label is "9400021515869043D48D42D47D41D46D2049DB3011A722030C7049DC0F442002";
    attribute INIT_2D of inst : label is "D101B000104B0E0F0308B67F08108949620F941DB67F0B68108949620AAAA41D";
    attribute INIT_2E of inst : label is "9C5B7DA5B6D35B5D55B4DB5B3D95B2DC7002B1C7F019849DC70221048D603940";
    attribute INIT_2F of inst : label is "DB5B9D95B8D1019C5D69579895B5558B58508CF036D96CC009DB0C519C5D5950";
    attribute INIT_30 of inst : label is "2CFCD5DCF0D4DA49A40AC3CB5B9D95BAD406901019BBCC5BEDA5BDD35BCD55BB";
    attribute INIT_31 of inst : label is "C9798953602620811D5DCF0D4DA298C6C025044C2C46F270AF98C00AAA098460";
    attribute INIT_32 of inst : label is "087988C03695010508041D33D42D34D43D35D968954535090450935F941D1940";
    attribute INIT_33 of inst : label is "8A36936D35935D34934D33933D32932D31931D30930DA79885095A7988D4C024";
    attribute INIT_34 of inst : label is "00890041D49DA0EE036DC101984DD32D31D30D0935D43D34D42D33D41D96C094";
    attribute INIT_35 of inst : label is "988CC009CF0C530197040D007F00934452535158035D5820C5A48D0B69582019";
    attribute INIT_36 of inst : label is "CF009CF035CC0F932DDD032D96CC0F931DDD031D96CC0F930DDD030D968C5C51";
    attribute INIT_37 of inst : label is "C0830D090271240CF009CF096D2DAAAAAAAC3C35D96C3034D96CF033D96CC009";
    attribute INIT_38 of inst : label is "5A55198F95045958A092C995A092CD75A35198F95025758A092A975A092AD060";
    attribute INIT_39 of inst : label is "921D0D20EE0C5B5A0396510A8C030C0065758AAA55895EEC958AAA35875E0759";
    attribute INIT_3A of inst : label is "402920D150906075F92902446658486C3986C292DD19A059F921D48919860E9F";
    attribute INIT_3B of inst : label is "4570252FD2F984645F960452C92CD82625F960252A92AD80620046029209F5C0";
    attribute INIT_3C of inst : label is "805E51616FFCE5050E4C30809881615F921981588160065404582565A65A6530";
    attribute INIT_3D of inst : label is "C1515AB51595E0006148FAD8FBDAA81515A8048095B5F9219802920995155016";
    attribute INIT_3E of inst : label is "3FF6F63F3FF6F6303FF63F006148F9D8FADAB5B6FADA95B5958B5B60515A14F9";
    attribute INIT_3F of inst : label is "2F63135224C40F6F6F6F6F6F61BF6F600F60D08EA4C268862C4AE0F640F6F6F6";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "0A0D09070701060C05060400030B0205010A0604050E05090403040D04080302";
    attribute INIT_01 of inst : label is "0D0A0C040A0F090A0705060F040A0305010A0204000E0F090E030D0D0C080B02";
    attribute INIT_02 of inst : label is "040A02040F0F0D0A0B05090F060A04050204080E06090504030F020900040F0F";
    attribute INIT_03 of inst : label is "07070502020D0F080D030A0E070905040204040E01090F040D0F0B090804060F";
    attribute INIT_04 of inst : label is "0B04080F050B02060F020C0D09090604030E0A090704040F020A0F050C000A0B";
    attribute INIT_05 of inst : label is "01040E0F0A0B060602020F0D0B090704030800030D0F0A0A07060401010D0E08";
    attribute INIT_06 of inst : label is "0501010C0C0808040400000C0C08080404080C03080F040A00060D01090D0508";
    attribute INIT_07 of inst : label is "080E040A0F060B02060F020B0D0709030402020D0D0909050501010D0D090905";
    attribute INIT_08 of inst : label is "080804050F020B0F060C02090D060903040C080803040F000A0D060901050D01";
    attribute INIT_09 of inst : label is "0B050702020F0D0D080A03070E0509020400080D030A0F070A040601010E0D0B";
    attribute INIT_0A of inst : label is "0F020A0F040D0F0B0A0905060F040A02050A0E07090404020F0F0A0C050A0007";
    attribute INIT_0B of inst : label is "0F0C0A0A04090F070A0605040F030A01050404010E0F090D040B0F0809060404";
    attribute INIT_0C of inst : label is "02090D07070601050C04060300020B01050804060E05090304020F00090F040D";
    attribute INIT_0D of inst : label is "02030D02070201010C01060100000B0005020A00040F0E0E090D030C0D0B080A";
    attribute INIT_0E of inst : label is "02000D00070001000C00060000000B0005060A0504050E04090403040D030803";
    attribute INIT_0F of inst : label is "C140F42B1BA0200B4AAD200BCE400A0D4A000A0004000E00090003000D000800";
    attribute INIT_10 of inst : label is "329C140D0EC340F4CC2A2F02B02A0D802A0D4AC82C72C540F7A4A0D6A0D0200B";
    attribute INIT_11 of inst : label is "5B02AB42CB40DCCC29CC40D0C0200B4AC144A090C061F4011FB6F5AB6D5AA561";
    attribute INIT_12 of inst : label is "64166561A181615A6580A0280A034A0A191E5A1C5A1825A1805AC54CB20094AD";
    attribute INIT_13 of inst : label is "85A6580A58565A58565A156540280A014ACE40A014A0A014A0A3B5E1A5C1A181";
    attribute INIT_14 of inst : label is "A6580A585A585A0280A014A0A191E5A1C5A2B18561A18561A3B12101210185A1";
    attribute INIT_15 of inst : label is "B5800BC645858FA6580A0B58565A58565A152500280A014AC540A034A0A014A0";
    attribute INIT_16 of inst : label is "200B4A02A65E0D5E58F45A58F411485800B5800B5E0D5E58F45A58F411485800";
    attribute INIT_17 of inst : label is "200B009321614A18010E300F3B6BC544A0290A02A490AAAAC202B02AB321D0C0";
    attribute INIT_18 of inst : label is "400B194AD02580A5800B5800B3D0C0200B0F0E60F0200B4AB42CB2888000B0D0";
    attribute INIT_19 of inst : label is "0B5800B580A2D0C0200BCC40D860F0200BC726B4200964AC72CB20094AD5B02A";
    attribute INIT_1A of inst : label is "40100BCE4180090A00999A0100B6A197C061F40100B6F9D12580ACE409D02580";
    attribute INIT_1B of inst : label is "F0C0F0C1F0C1F0CA0200BA82F6A182A0090A0099AA0100B5A60090A60B6C061F";
    attribute INIT_1C of inst : label is "A00C8D0C0200B2F0200B2F029AD02AB1BA0200BCC40B5E60090AA904F0A0D0C0";
    attribute INIT_1D of inst : label is "0A0A4800B4800B186C52CB200932461010E300F31A6D8258580A580A188DFC00";
    attribute INIT_1E of inst : label is "C60091600B0091600B1CC21B2C60091600B0091600B1CA21B1C00B1AF1C8194B";
    attribute INIT_1F of inst : label is "B58C7BA01A18009580A60091E00B0091E00B3C9260091E00B0091E00B3CD21B3";
    attribute INIT_20 of inst : label is "090A2097A2092090A2096A1AA5ADC1458561C7B038F00E0B0C00AA6B424858C7";
    attribute INIT_21 of inst : label is "4804603A04804603A0480461F03A23E22D2C62092090A2096A0387A418C945A2";
    attribute INIT_22 of inst : label is "0612A180611A180AB2243B1BA0200B1AC1258C7B58AC7B580AA0CF4C120A0AD0";
    attribute INIT_23 of inst : label is "90A0D0AC120A0A0D0C7650090A2097A2090A209DBB209DBB7A0E344481AC1218";
    attribute INIT_24 of inst : label is "44445AC42025AC4244445ADA21C10F3025A6B42520956A20956A0090A0090A00";
    attribute INIT_25 of inst : label is "7050200070502060090A0090A0090A0090A4ADA430312DA41C0F16DA215ADA21";
    attribute INIT_26 of inst : label is "0D7A03E21B5E0100705020007050200070502000705020007050200070502000";
    attribute INIT_27 of inst : label is "21A18000000B181E4ACF4182E30B3CCF4181E32A0B2C291C1800B0093206100B";
    attribute INIT_28 of inst : label is "AF4F04AD0480604A090480469048046F163E20D600916BA0091619A181641641";
    attribute INIT_29 of inst : label is "293207804AC740A804A0F0CA0F0CA04E1B0C04A49480483F04C8DF104E3C04A0";
    attribute INIT_2A of inst : label is "A04807A04807A07804A07804A07804ACB40A804A0A804A0A804A1F0CA6A6A6B3";
    attribute INIT_2B of inst : label is "85A185A0480AA0480AA0480AAC32198CA010D20D0CA03E2CA0A185A185A04807";
    attribute INIT_2C of inst : label is "180A0A181610A604807A04807A04807A1D0CAC32198CA010D20F0CA03E2CA0A1";
    attribute INIT_2D of inst : label is "A00E01E900E05C6CD0EE1ADA23031121C0F0204B1ADA2183031121C0F444404B";
    attribute INIT_2E of inst : label is "A58C7A58C7A68C7A68C7A58C7A58C7ADB21ACA4DA20610CADB20A1F0CA1F0C02";
    attribute INIT_2F of inst : label is "A58C7A58C7A2D1C1A1E180611A586E35AD028C3201B1AC220AC32180A0818180";
    attribute INIT_30 of inst : label is "AC645CBC625CBA1600FAC1458C7A58C7AFD1C6092CCC458C7A58C7A68C7A68C7";
    attribute INIT_31 of inst : label is "8C0611AAE61E0DC195CBC625CBA061C640A0362C6468FA0F0026C52444F24680";
    attribute INIT_32 of inst : label is "1A0E390D01B8A5F8ECB04E01B04E01B04E01B1A318A8A80A6A80AA8FA0280A19";
    attribute INIT_33 of inst : label is "A801901B01901B01901B01901B01901B01901B01901BA0E3A3F1CA0619C040AF";
    attribute INIT_34 of inst : label is "0ADC260280AB52B02019DA206105A0190190190A01904A01904A01904AA8CD1E";
    attribute INIT_35 of inst : label is "A1FC220AC321A1F0C1F02A0ADE20A6AA81AA81A0DAC1AD125A5AD125A5AD120A";
    attribute INIT_36 of inst : label is "C626AC626AC221201BCD201B1AC221201BCD201B1AC221201BCD201B1AD18160";
    attribute INIT_37 of inst : label is "8EE0190A0ACCCC6C626AC621ACFBA444444C4401B1AC4201B1AC3201B1AC220A";
    attribute INIT_38 of inst : label is "8448061F401486E368C00B6868C00B68448061F401486E368C00B6868C00B6FD";
    attribute INIT_39 of inst : label is "200B6B52B02681A0F0CFA1DA9310025B4C6614444616AC546614444616A096C6";
    attribute INIT_3A of inst : label is "0F0200B280A4A64832A624A4A4848C441AC442A0090A0D0C0200B0490AA090C0";
    attribute INIT_3B of inst : label is "4C294C00700B14E48F4014800F00B34E48F4014800F00B34AFF4CFD0200BC246";
    attribute INIT_3C of inst : label is "A486A2C2CC34684A6CC40BA161928290200BE299E2A1B4C1B4614A4844604829";
    attribute INIT_3D of inst : label is "4482BC182B180B64A4A4CAB4CABA09482BCA481D1C180200BED0200B182B6F2A";
    attribute INIT_3E of inst : label is "DCC3C3DCDCC3C3DEDCC3DC64A4A4CDB4CDBA1610CCBA1A181E31A1C482BC48C8";
    attribute INIT_3F of inst : label is "1C3D4D1D1DBD9C3C3C3C3C3C3D2C3C3DDC3DCDCEEEDDCBA9865310C3D9C3C3C3";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
