-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_pgme is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_pgme is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "6F6F6F6F6F6F6F6F6314C40F6F62EF6F6F641F6F63EF626F617F623203C22342";
    attribute INIT_01 of inst : label is "C40F6F6F6F6F6F6F64C40F6F6F6F6F6F6F6F64C4C17F649181E44434035F6F6F";
    attribute INIT_02 of inst : label is "6F64C40F6F6F6F6F6F6F6F6F6F6F6F6F6F6F6F6F6F6F6F64C40F6F63AF6F6F64";
    attribute INIT_03 of inst : label is "D09F7C8600938020939005F0D50990530D579B52CD952ADF7C23C8A4C4C40F6F";
    attribute INIT_04 of inst : label is "392D919219A909219F7CF7CF7C20939DA094AB0820D0994592DDF921DB916D10";
    attribute INIT_05 of inst : label is "F7C100B509A509950921D099616F7C86099A815C30B933D33E20D39F7CDA020D";
    attribute INIT_06 of inst : label is "7C86009A808D0AB00900841D41D9542D42DA543D43D8800F4B516D10D0911D09";
    attribute INIT_07 of inst : label is "64D169109092292D919239092091920392099035F7CDA0AB059002D94920919F";
    attribute INIT_08 of inst : label is "AA892D9A83B023C23C6039209F7C0D20EE0C49035D0C5F7CAB0095015965D149";
    attribute INIT_09 of inst : label is "92192CD2C92BD2B92AD2A929D2992DD49DE020D892CC300AD3931F7C8602B98A";
    attribute INIT_0A of inst : label is "89209DE000A51994A896F7C209090413939129092D9F9209092F939229219390";
    attribute INIT_0B of inst : label is "2D092DDF920D22D092FD3921D390921D2C92CD2B92BD2A92AD29929D2D949209";
    attribute INIT_0C of inst : label is "C26D8063E026926D28928D27927D82690420979209F7CD6020939F7C0613D391";
    attribute INIT_0D of inst : label is "696D034D23CF7C86029A820D39F7C25F926D13D12D49F0F431D33D3509D035F7";
    attribute INIT_0E of inst : label is "33E860F9200979A33D9688229093FC94A034D0C4B600D6A4095229834DAD5C4B";
    attribute INIT_0F of inst : label is "926988920790AD01CF7C3E020D7920DF7C2EDF92ED8090AD23C23CF7C3035F7C";
    attribute INIT_10 of inst : label is "20901CA88A88F7C86009A820D39F7CF7CDA026DF926D88920790ADF7CDA0269F";
    attribute INIT_11 of inst : label is "D39F7CDA026D8063E00426926D28928D27927D826920D3925930091982599019";
    attribute INIT_12 of inst : label is "20DF7CD6025922933D092D9A4FD20D39A0293920D70229AF7C86009A82190920";
    attribute INIT_13 of inst : label is "D602DD20D1AD0924D22DF91BD13D1921D890921DF7C30E9959059F921DA02939";
    attribute INIT_14 of inst : label is "F9B58A95A0B5F191095FF98D5D5AAD594C5B5A595B6B5F960B59695F96095F7C";
    attribute INIT_15 of inst : label is "58A0B90070F915AAA20301080D22010940C70940C70948094840F39B58A95F0F";
    attribute INIT_16 of inst : label is "A0F981010091590B9C08F0E630E58E515096680656509408980D151920879794";
    attribute INIT_17 of inst : label is "AC556C30A96555588555588192009C58029C0AAC9C5C0601009A0E589810E515";
    attribute INIT_18 of inst : label is "D620200945E04580558F909AA0839C5FF35442F8046C0304655406998558AAAA";
    attribute INIT_19 of inst : label is "C06300A0DC98320020A3095F9870952200800A958F950099095220070A4555D6";
    attribute INIT_1A of inst : label is "E02601BDB01ED1CD091BDF901CD1CD81BD1BD81AC00D9202980F079203960490";
    attribute INIT_1B of inst : label is "AD7569D11D62D10D61DAAA1BD1BD12D1EC00201CD12D0090AA12E88212E13E1F";
    attribute INIT_1C of inst : label is "1ED098011C717109401AD1ED095078CE01ED0990DD0A10E1FC0101ED90C00856";
    attribute INIT_1D of inst : label is "91DD1DD12DB087181FC094013D1000D11C90D89A90D9990D90D897BCC090D13D";
    attribute INIT_1E of inst : label is "DA00A8198F950F94084C1100092009063C30890C10E1FE13D13D8007179C1ED0";
    attribute INIT_1F of inst : label is "100020980027DC802C4A009F9A09820811AA8111009F9A09808850118D5D11D4";
    attribute INIT_20 of inst : label is "112500F21526A2481000AAF506A04810A00C4007DC8A09000262015158811A81";
    attribute INIT_21 of inst : label is "55C545800EEEEEEEEEEF00008501109A81100C5C0118C5F9C51511805118F935";
    attribute INIT_22 of inst : label is "810181018101804096730C9A4995690860AD620E988AD02988884C69860A49D5";
    attribute INIT_23 of inst : label is "885D58858D5885D588580280989CF9005E5F5D50985011098110900181018101";
    attribute INIT_24 of inst : label is "5C5D0AA85F985C0F9852040198F985D0F9F0952270890A8858320050850208D5";
    attribute INIT_25 of inst : label is "0DC0F425B515A5011C5F99581185811F9B5811A500085096085C1109A5811008";
    attribute INIT_26 of inst : label is "DE048DA5C8508DB0009602C5B7DA50935B5DB50995C9C70AACDAA908975F0194";
    attribute INIT_27 of inst : label is "097F0B57F030AAAAB5880E645D8809E547DC7042A045D45D40D93C4AD40D9049";
    attribute INIT_28 of inst : label is "4DDC70A2D0F4C7062A4CC700280D5C039C5C70A2EF0A4C7F0097F0097F0097F0";
    attribute INIT_29 of inst : label is "98D0820925B515A57FC810C47FCC6508ECA80A707207F0F987F08AAAA8C10198";
    attribute INIT_2A of inst : label is "00800097F040098D082098001979016161167D81166D00A8920A9AA894DD8000";
    attribute INIT_2B of inst : label is "08F987F08AAAA8C1042DC70827F019849DC7022E048D8001916161161D81160D";
    attribute INIT_2C of inst : label is "108D0C6B9790C8C30D5C589D54984DDE539C70E2C402209C70C2C7042C70227F";
    attribute INIT_2D of inst : label is "0020949D48D47D097F08F987F08AAAA8C10198D57F009809792079AAF5D029E5";
    attribute INIT_2E of inst : label is "108AAAA47D847D848D849DC0D54DD49DE6D48DE5D47DE4DAB5AB5198AAD0D58D";
    attribute INIT_2F of inst : label is "89AA89D58D0C6C97907F0849D7F08AAAA49DA00F948DA00AAAA48DA0047D7F08";
    attribute INIT_30 of inst : label is "06BD50D5B082620152981511D5D811D4DAF9800C1B4B6B5F9D5D9DC5D8DA6920";
    attribute INIT_31 of inst : label is "0970730F9A698008197F009208D0072049D848D847D8BDC30E6C5C98C5D54983";
    attribute INIT_32 of inst : label is "CC532E09D08508B5B5B59670B50995808D000E209800197F00900730C9A097F0";
    attribute INIT_33 of inst : label is "89809AAAA808D32EE5B18D5B132C8D0C6B580019C509790B5D100E5B18D5B132";
    attribute INIT_34 of inst : label is "B4811D5D811B4D4DAD48F9C5D1B5091082019804019F90087F00900200930D90";
    attribute INIT_35 of inst : label is "00000E8EA08E0000E5E6D7D8D9DADBDCDDDEDFD0C4CC509B532E85C8B400C4D4";
    attribute INIT_36 of inst : label is "6000000000EE2AE2600000000C6E80E000000000EA0EC0600000000CE2086000";
    attribute INIT_37 of inst : label is "0E4C02C000E206800A6C60ECEE2AE2606CC6C2C0000086CE8EC00000000E06A0";
    attribute INIT_38 of inst : label is "900500100700500200000700500200000662020000000000A6EA2A000000046E";
    attribute INIT_39 of inst : label is "D520294039C5C70C200900500100700300900500100700300900500100700300";
    attribute INIT_3A of inst : label is "25262D2E1114160E0C0A0A080730F9A298055C03939C57F08F987F08AAAA8C10";
    attribute INIT_3B of inst : label is "6C60636B616262696C6F6A636E6051575B595157464A4843423E34333231362B";
    attribute INIT_3C of inst : label is "5B55575B474A4842403D34303D3C3C31252F20271B1B1A130802020276726369";
    attribute INIT_3D of inst : label is "2526272E261A13190F0A0A00767263696C60636B616262696C6F6A636E60515A";
    attribute INIT_3E of inst : label is "6C60636B616262696C6F6A636E605851525C5E5946434844413F34363C3B3438";
    attribute INIT_3F of inst : label is "59535355574C48464240343534333A3E252D2E252114101F0603030A76726369";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "3C3C3C3C3C3C3C3C3DFDBD9C3C3D4C3C3C3D2C3C3DEC3D2C3DDC3D3D3DCD1D7D";
    attribute INIT_01 of inst : label is "BD9C3C3C3C3C3C3C3DBD9C3C3C3C3C3C3C3C3D3D3DDC3D0D4D2D2D3D5D6C3C3C";
    attribute INIT_02 of inst : label is "3C3DBD9C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3C3DBD9C3C3D0C3C3C3D";
    attribute INIT_03 of inst : label is "90AC34C420AD720090A1BD12580A0BD02580A5800B5800BC34D14A8DBDBD9C3C";
    attribute INIT_04 of inst : label is "0A0090A00900F200BC34C34C340090AB221AC12A0090A182A0091A0090A20920";
    attribute INIT_05 of inst : label is "C34D82580A585A580A0090A184AC34C420AA9D640D0C00A00E0090AC34B22009";
    attribute INIT_06 of inst : label is "34C420AA96CA2C120A0AD0480465A0480465A0480461F23E25A2092090A2096A";
    attribute INIT_07 of inst : label is "56A2092090A0090090A0090A0090AFD0200BFD7AC34B22C122A0A0091A0090AC";
    attribute INIT_08 of inst : label is "441200BA9D92D14D14FD0200BC346B52B02680D7A0D6AC34C120A0A20956A209";
    attribute INIT_09 of inst : label is "200B00900B00900B00900B00900B0091AB320090ADA40160A1000C34C42D4BA4";
    attribute INIT_0A of inst : label is "0000BB325F920A1AA918C340090A482097A2090A0091A0090A0090A00900900F";
    attribute INIT_0B of inst : label is "090A0091A0090090A0090A00900F200B00900B00900B00900B00900B0091A009";
    attribute INIT_0C of inst : label is "400964ACE200900B00900B00900B400B48009F200BC34B320090AC34482097A2";
    attribute INIT_0D of inst : label is "8181F00AD14C34C422AA90090AC3478F400A008008EA03E2008008780A1F7AC3";
    attribute INIT_0E of inst : label is "0DEC421A092C1600DA1A660090AD7418FF00A61A1AFD1CC1F1C00BA00BA18181";
    attribute INIT_0F of inst : label is "20071F0018260ADD4C34CD2009F200BC340093200713260AD14D14C340F7AC34";
    attribute INIT_10 of inst : label is "00BDD4A6A849C34C422AA90090AC34C34B22009320071F0018260AC34B220093";
    attribute INIT_11 of inst : label is "90AC34B2200964ACE24800900B00900B00900B400B0090A0090B1C06100B3D02";
    attribute INIT_12 of inst : label is "00BC34B320090090D80A009003A0090A1B0C0200BFD00D8C34C422AA90090A00";
    attribute INIT_13 of inst : label is "B220090092090A009009FA2092097A00900F200BC340B1C7A0D0C0200B3B0C02";
    attribute INIT_14 of inst : label is "6D56145A195CB7B295CB6BA5656005A18585A585A5E58F4015A5E58F4015AC34";
    attribute INIT_15 of inst : label is "AA0B1C1F3B129B4440B0F0E70A0A0621110003332261A361A10BB7D56105A0BB";
    attribute INIT_16 of inst : label is "CB1A10FD9269B0B1C1B31D8D2F8B189990A9C0F9A98FA0D0270A990E0990C029";
    attribute INIT_17 of inst : label is "48AD6403C8F989636F8F6430A0F128A0D060F44028A0F190E0A29897A30F8B99";
    attribute INIT_18 of inst : label is "8E0B0C0AF803F60B963F40641FA028A770000070DFE0D0CFEF813D1F3FAA4444";
    attribute INIT_19 of inst : label is "7070107211110006F1C0389E610F8B0A1D9F1C89CE6091C0F8B0A0A2B49A988E";
    attribute INIT_1A of inst : label is "80A4F02A4D02A0280A0280A6028020602802040280A0A0D0A0DFA0A0D0A0D0A0";
    attribute INIT_1B of inst : label is "7B98D7B038D7B038D7BA0802802403A0282A0D02203A8AF9C003630A03803802";
    attribute INIT_1C of inst : label is "0280A0903E9B990A0F02A0288A21D940A0284A84909003A02A60D02A8080A98D";
    attribute INIT_1D of inst : label is "A02802003AF1899802A0A1F0342970A03E8080AE8080A8498080AD840A84903A";
    attribute INIT_1E of inst : label is "BA0A00061020F0209D54190A2A0DCA6DB40D980803E02E03803610A99D840280";
    attribute INIT_1F of inst : label is "90A8A4AFD6ADF496A0AEDA01242E32DC19688190AE01242E362D0219C5CB195C";
    attribute INIT_20 of inst : label is "190B0A9AA8A20A88090A0898A20A880900A080ADF49A700A61E09181639198C1";
    attribute INIT_21 of inst : label is "7A487A4C0B4B4B4B4B41D006D0219608C190A0AAD19C0412040B19C0B19C120B";
    attribute INIT_22 of inst : label is "DADACACABABAA6FD1CDE25AAAA180A6AFDC4E094619A0F0E36AD8406103C0A48";
    attribute INIT_23 of inst : label is "9090FA0BE099090FA0B30A40ADE4FA6180808080AD02198AC198A0AAFAFAEAEA";
    attribute INIT_24 of inst : label is "00AD1CC09120B1D120B092B061F40B2DF4010B0A3F9F1CA0190A0A4D6EF0EE09";
    attribute INIT_25 of inst : label is "2A31E218AA18AA61900120AC190AC19120AC190A0A6D02D52D0419400AC190A0";
    attribute INIT_26 of inst : label is "A0F0CAD14D028C320A180A58C7A584A68C7A586A58EADB2AD5BA40B0CFA0D0C0";
    attribute INIT_27 of inst : label is "0ADA21ADA20F444418DF11C0461F0A1804ADB23A3F04A07804ADD40A804A0F0C";
    attribute INIT_28 of inst : label is "05ADB21A13E2DB20AD34DB22A0D8A0F028ADB22AD62D34DA20ADA20ADA20ADA2";
    attribute INIT_29 of inst : label is "AD122A0A18AA18AADA430312DA41C0F155556C82DA2DA2026DA2344444DA2061";
    attribute INIT_2A of inst : label is "0AD120ADE28A0AD122A0AD120ADF21E1E1956BC1956B0AA0A090C447205AD120";
    attribute INIT_2B of inst : label is "21026DA2344444DA202ADB21ADA20610CADB20A0F0CAD120A1E1E1957AC1957A";
    attribute INIT_2C of inst : label is "CAD121ABADF2D34011A18CA180E305A180ADB21AD620A9ADB21ADB21ADB21ADA";
    attribute INIT_2D of inst : label is "20A1A0380380380ADA21026DA2344444DA20611ADE20AAE00A0D02446A0D0C1A";
    attribute INIT_2E of inst : label is "0F3444403A403A403A403A0D1C05A038D2B038D2B038D2BA160180E3441F1AD1";
    attribute INIT_2F of inst : label is "1C44721AD121A0ADF2DA2103ADA21444403AD620203AD62444403AD6203ADA21";
    attribute INIT_30 of inst : label is "B02C031AD161E09180611A195CBC195CBA7240A4B1A1E18FA48D5B48D5BA1A09";
    attribute INIT_31 of inst : label is "0A8ADE22AA1AD12A0ADE20ACAD126DA2038603860386D240F1C180E31A180611";
    attribute INIT_32 of inst : label is "A18008E2B6DF1818161A100A180A18F6D120AFA1AD120ADE20A0ADE22AA0ADE2";
    attribute INIT_33 of inst : label is "02AC044444E2B00A989BC989B00AD121A1AD120A080ADF2189B0A989BC989B00";
    attribute INIT_34 of inst : label is "18C195CBC191A5CBA18C72189B180A0AD120A6A0F0C021A6DE20A0A0DC20DA0F";
    attribute INIT_35 of inst : label is "0800013330312000D1D0DFDEDDDCDBDAD9D8D7D7DD4180A18008D0481AE1121A";
    attribute INIT_36 of inst : label is "2000080000123314100080000211333000080000133133200080000333031200";
    attribute INIT_37 of inst : label is "0123033008123232012313329233141042213338000031231330008000013133";
    attribute INIT_38 of inst : label is "2052052051001051001050000050800004140330000800001223310000800412";
    attribute INIT_39 of inst : label is "8A0D0A0D028ADB22A05805805805705705605605605505505405405405305305";
    attribute INIT_3A of inst : label is "EFEBE7E4EEE7E1EFEDEBEBE86DE25AA5A0F9A0D04028ADA21026DA2344444DA2";
    attribute INIT_3B of inst : label is "EBEBEAE8E7E6E5E4E2E1E1E1E0E0EBEDE8E6E5E1EDEBEAE6E2EDEDE9E6E3E1EF";
    attribute INIT_3C of inst : label is "E9E7E5E2EEEBEAE7E3EEEDEAE7E4E1E0EFEDEAE6EFE8E2E0EEECECE9E2E0EEEC";
    attribute INIT_3D of inst : label is "EFEEEAE6E1EAE4E0EEECECEAE2E0EEECEBEBEAE8E7E6E5E4E2E1E1E1E0E0ECEE";
    attribute INIT_3E of inst : label is "EBEBEAE8E7E6E5E4E2E1E1E1E0E0ECEFEAE7E5E3EFECEAE8E4EFEDEBE8E5E2E0";
    attribute INIT_3F of inst : label is "EAE8E6E4E0ECEAE9E5E1EDECE8E5E2E0EFEEEAE7E3ECE6E0EFEDEDEAE2E0EEEC";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
