-- generated with romgen v3.0 by MikeJ
library ieee;
  use ieee.std_logic_1164.all;
  use ieee.std_logic_unsigned.all;
  use ieee.numeric_std.all;

library UNISIM;
  use UNISIM.Vcomponents.all;

entity rom_vecb is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(11 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end;

architecture RTL of rom_vecb is

  function romgen_str2bv (str : string) return bit_vector is
    variable result : bit_vector (str'length*4-1 downto 0);
  begin
    for i in 0 to str'length-1 loop
      case str(str'high-i) is
        when '0'       => result(i*4+3 downto i*4) := x"0";
        when '1'       => result(i*4+3 downto i*4) := x"1";
        when '2'       => result(i*4+3 downto i*4) := x"2";
        when '3'       => result(i*4+3 downto i*4) := x"3";
        when '4'       => result(i*4+3 downto i*4) := x"4";
        when '5'       => result(i*4+3 downto i*4) := x"5";
        when '6'       => result(i*4+3 downto i*4) := x"6";
        when '7'       => result(i*4+3 downto i*4) := x"7";
        when '8'       => result(i*4+3 downto i*4) := x"8";
        when '9'       => result(i*4+3 downto i*4) := x"9";
        when 'A'       => result(i*4+3 downto i*4) := x"A";
        when 'B'       => result(i*4+3 downto i*4) := x"B";
        when 'C'       => result(i*4+3 downto i*4) := x"C";
        when 'D'       => result(i*4+3 downto i*4) := x"D";
        when 'E'       => result(i*4+3 downto i*4) := x"E";
        when 'F'       => result(i*4+3 downto i*4) := x"F";
        when others    => null;
      end case;
    end loop;
    return result;
  end romgen_str2bv;

  attribute INIT_00 : string;
  attribute INIT_01 : string;
  attribute INIT_02 : string;
  attribute INIT_03 : string;
  attribute INIT_04 : string;
  attribute INIT_05 : string;
  attribute INIT_06 : string;
  attribute INIT_07 : string;
  attribute INIT_08 : string;
  attribute INIT_09 : string;
  attribute INIT_0A : string;
  attribute INIT_0B : string;
  attribute INIT_0C : string;
  attribute INIT_0D : string;
  attribute INIT_0E : string;
  attribute INIT_0F : string;
  attribute INIT_10 : string;
  attribute INIT_11 : string;
  attribute INIT_12 : string;
  attribute INIT_13 : string;
  attribute INIT_14 : string;
  attribute INIT_15 : string;
  attribute INIT_16 : string;
  attribute INIT_17 : string;
  attribute INIT_18 : string;
  attribute INIT_19 : string;
  attribute INIT_1A : string;
  attribute INIT_1B : string;
  attribute INIT_1C : string;
  attribute INIT_1D : string;
  attribute INIT_1E : string;
  attribute INIT_1F : string;
  attribute INIT_20 : string;
  attribute INIT_21 : string;
  attribute INIT_22 : string;
  attribute INIT_23 : string;
  attribute INIT_24 : string;
  attribute INIT_25 : string;
  attribute INIT_26 : string;
  attribute INIT_27 : string;
  attribute INIT_28 : string;
  attribute INIT_29 : string;
  attribute INIT_2A : string;
  attribute INIT_2B : string;
  attribute INIT_2C : string;
  attribute INIT_2D : string;
  attribute INIT_2E : string;
  attribute INIT_2F : string;
  attribute INIT_30 : string;
  attribute INIT_31 : string;
  attribute INIT_32 : string;
  attribute INIT_33 : string;
  attribute INIT_34 : string;
  attribute INIT_35 : string;
  attribute INIT_36 : string;
  attribute INIT_37 : string;
  attribute INIT_38 : string;
  attribute INIT_39 : string;
  attribute INIT_3A : string;
  attribute INIT_3B : string;
  attribute INIT_3C : string;
  attribute INIT_3D : string;
  attribute INIT_3E : string;
  attribute INIT_3F : string;

  component RAMB16_S4
    --pragma translate_off
    generic (
      INIT_00 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_01 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_02 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_03 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_04 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_05 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_06 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_07 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_08 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_09 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_0F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_10 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_11 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_12 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_13 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_14 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_15 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_16 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_17 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_18 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_19 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_1F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_20 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_21 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_22 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_23 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_24 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_25 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_26 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_27 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_28 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_29 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_2F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_30 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_31 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_32 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_33 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_34 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_35 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_36 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_37 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_38 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_39 : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3A : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3B : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3C : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3D : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3E : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000";
      INIT_3F : bit_vector (255 downto 0) := x"0000000000000000000000000000000000000000000000000000000000000000"
      );
    --pragma translate_on
    port (
      DO    : out std_logic_vector (3 downto 0);
      ADDR  : in  std_logic_vector (11 downto 0);
      CLK   : in  std_logic;
      DI    : in  std_logic_vector (3 downto 0);
      EN    : in  std_logic;
      SSR   : in  std_logic;
      WE    : in  std_logic 
      );
  end component;

  signal rom_addr : std_logic_vector(11 downto 0);

begin

  p_addr : process(ADDR)
  begin
     rom_addr <= (others => '0');
     rom_addr(11 downto 0) <= ADDR;
  end process;

  rom0 : if true generate
    attribute INIT_00 of inst : label is "08FCA0F8001F110AAA00FE0A000A0A08FE0008065BBBB00A66B0B50800550002";
    attribute INIT_01 of inst : label is "0A04F606A0000600F40A000C0A0600FCFEF202FCF60AA5650AA5650A000A000A";
    attribute INIT_02 of inst : label is "08065BBB00F8B508005500020A08F60510FC08BB08F8BB065BFC0200F60A080A";
    attribute INIT_03 of inst : label is "D552B235BDE5EBB33BBE90000A0C001BF1FCF40AA5650AA5650A000C0A08FE00";
    attribute INIT_04 of inst : label is "0AA16DCC84007E6FEA453B166EB651A126ABF5FAA25CBD9200705EDB532B255D";
    attribute INIT_05 of inst : label is "4F22A84EC0ED4F00D28E8E3E31C343D1DE3E008C60FA364C066FA344A016DAC4";
    attribute INIT_06 of inst : label is "F3DCD4FD2D2300DEF83652042C86EE1C3200C1C77441137B59DFFE4F00C1AB81";
    attribute INIT_07 of inst : label is "42A82E41E300FC9CC9F2D157751D2F1400FC5AF814E28A240C3E1400ED282823";
    attribute INIT_08 of inst : label is "B73114CF0041638FC1EE68C24025CF003E8282D2DF4DCD3F32D2002D8FA5E3C0";
    attribute INIT_09 of inst : label is "04B21C0023E8E8ED1D343C13E3ED003218BADE0CE48A22F4DE0041477CEFFD95";
    attribute INIT_0A of inst : label is "DE3E00E3816D2B40CE68E2CF2D00F494491C3FB99BF3C11C00F4D618FC2E86EC";
    attribute INIT_0B of inst : label is "00C12C4F22036D4324F3B3BEE9F2C0ED4F00D20C3E31124B504404C4B0CBF2D1";
    attribute INIT_0C of inst : label is "2E5204E17225D5D1AEFC1AF0EE1C3200C13B4113026F3406E2A0CD1AE0DFFE4F";
    attribute INIT_0D of inst : label is "E2D036D4C2DFDB2B7EEF0C3E1400ED4023F3E15405C4C0CC0B5CEFFD2D2300DE";
    attribute INIT_0E of inst : label is "E7B2BDFD2C4D630D2E41E300FC55F2D1E016C3A0EE0A3C610E1D2F1400FC4214";
    attribute INIT_0F of inst : label is "EA1D5D52271E4025CF003E04D2DFFEC5B0CC0C4C50471C3F32D2002D24E3C0FE";
    attribute INIT_10 of inst : label is "4234D63022F4DE0041B3EFFD0EA1DC0A2E6043F6203114CF0041E2C1EE0FA1CF";
    attribute INIT_11 of inst : label is "922104B21C0023C0ED1D2FBC0B4C404405B42113E3ED0032C2DE0C2F9EEB3B3F";
    attribute INIT_12 of inst : label is "E2CF2D00F4DD1C3F20FA4D602206D4AF02F3C11C00F4EEFC2E10FA1C6E3135E5";
    attribute INIT_13 of inst : label is "7ED1D0ED2D30313E313F4034D4C0DFD1DE3E00E3EE2B4012295E5313E6C1AF01";
    attribute INIT_14 of inst : label is "00B0D8EF3AEED78BDFE1FB3E31224F22314115C3CEEEC0ED4F00AC08E008E008";
    attribute INIT_15 of inst : label is "BFFCFDEE1C320700A4A6FE5BFEA6BAEDEE0C40221241133133F5B1DDFDDFFE4F";
    attribute INIT_16 of inst : label is "03F323F31304C3CD0C1DFD2D23008883FE8DFE93E7EEFD2D3112F352042224D4";
    attribute INIT_17 of inst : label is "2E9D581DFE5F23F3E214E2F3F4B1DC2C2E0C3E14004A800E800E8027FD0D3E32";
    attribute INIT_18 of inst : label is "41E300CAAA2F552FAA6B3E2E4004E2E3F2D1F3D3BFFB3D3F1D2F14000B8D1E63";
    attribute INIT_19 of inst : label is "D1C0DC3C40313F32D20088D821362FD99E2E3F32F5EFD1E3C0E2C2CD1B4F3F2E";
    attribute INIT_1A of inst : label is "2113D2DFEEC1EEDFCFFB4D42224025CF00640820082008923F3023E3D0DFD2DF";
    attribute INIT_1B of inst : label is "6A12B5126A58212204C0EEDEEFFDDFDD1B5F33133114CF00503821D82039873F";
    attribute INIT_1C of inst : label is "04F313E3ED00888DF2A3127D292213E3BF1EFDDE0CEEEC3C51141322F4DE006C";
    attribute INIT_1D of inst : label is "2EFC2E1D1C5F34E4E204B21C00C68002800280E91303D2DE0D1DED1DFD0C4D43";
    attribute INIT_1E of inst : label is "6685F2E2C00C2E2F1C3F1D3D5115D3D1F3C11C000583F28D02739813F2D1ED1D";
    attribute INIT_1F of inst : label is "04008838E1D8E13772E2D1DE1D2F312B402E4E43F5C1D1E2CF2D004666E1BBE1";
    attribute INIT_20 of inst : label is "D8C1CFEC2C74EC384F4124E400D230300CD0D0AB3308D3C0DD0C97DD083D4033";
    attribute INIT_21 of inst : label is "F3C2008B76673D9AA9F804A6C0DD0C3D600C6A403304D300B74B4B2CA5E5C924";
    attribute INIT_22 of inst : label is "D380DD0C3D40993D803304D3C0003DB4B44E5E5A29F483CEFC1D4E7C1C8D4214";
    attribute INIT_23 of inst : label is "D3C0DD009B565242BCBC7CC28DFC1C4E42C74E8314F4C2CE00ED0303400D0D5A";
    attribute INIT_24 of inst : label is "72CFD82C4F3124474138E4C1DFEC0058A79633697A8FC0AA0C3D403306406604";
    attribute INIT_25 of inst : label is "C1CFEC2C003ED0D004303065DD083D403304793308D3C0DD0C0033CBCB242565";
    attribute INIT_26 of inst : label is "67180C6A403304D3A004A6C0DD0C3D0059A5E5E44B4B47EC384F4124E49C24D8";
    attribute INIT_27 of inst : label is "80DD0C3D4000D35E5AC2B4B4E71C8D4214F3C294F483CEFC1D4E00859AA9D376";
    attribute INIT_28 of inst : label is "5652944E8314F4C2CE49C28DFC1C4E4200230D0DC00303B63D803304D3C077D3";
    attribute INIT_29 of inst : label is "CFD82C4F312400B8697ADDA79681406604D3C0DD0AC0AA0C3D40330075BCBCCE";
    attribute INIT_2A of inst : label is "2C00AF41C163AC6C313F82828282DFD10C00DD2565ECCBCB9E4138E4C1DFECC9";
    attribute INIT_2B of inst : label is "4E008624CE7BF9711331479C479CFDDF3D00A332C05FCA8E2231758E658FEEC0";
    attribute INIT_2C of inst : label is "42001AF4FCD64A46F313E8E8E8E81DFD40005904ED982864042218BA28B9FDEE";
    attribute INIT_2D of inst : label is "2400A8C22C577FF7D1F3944994493F1D3300DAE30C156C28E2F3B728B6182E0C";
    attribute INIT_2E of inst : label is "E40061CF41AB64A4DFD18E8E8E8E313F040075C03E8982C6C0E2816B827B3F2E";
    attribute INIT_2F of inst : label is "C2008AEC4295179FFDDFC974C9741331D3006DDE40B14682EEDF9B82AB812240";
    attribute INIT_30 of inst : label is "CE00F61C143AC6CA1DFD28282828F313C000B70C2378E8AC0CEEF856E8571322";
    attribute INIT_31 of inst : label is "EC00684EE4B991193F1D7CC77CC7D1F3DD00362D04FBA4E82E1D59E85AF8E204";
    attribute INIT_32 of inst : label is "30D0330AA13E315D602306E3A0BDD1DE3E009B40D2878E4A402E8FA58E95D1E2";
    attribute INIT_33 of inst : label is "BC41136145F3C4D1BCFADFFE4F0031C53E2AAF4F22605213E6D2AEDBC0ED4F00";
    attribute INIT_34 of inst : label is "06D2A0DE0A3BFD2D2300135C856EBA52045326E3A2DFEB0AEE1C32002299594C";
    attribute INIT_35 of inst : label is "4B6F1D2F1400F3BC23621A14E206E5D1AEED2A5D0C3E1400030DD360FA23F335";
    attribute INIT_36 of inst : label is "D200D145B8266DE3C0D5A2DEEA1D5E602E41E300E27975444DF2D1F6B4DFCCFD";
    attribute INIT_37 of inst : label is "D2E661C1EEA0BEFD2A3E62354025CF00D030DD066FD2DFB3A0ED0A2D60533F32";
    attribute INIT_38 of inst : label is "0CBDEA2D6E31250622F4DE00EE77B7C434EFFDAFCB1D4C3F54163114CF00DF4B";
    attribute INIT_39 of inst : label is "6223E6B304B21C000D033DA016ED1DDB0A3E603206D513E3ED00FDB48BA236DE";
    attribute INIT_3A of inst : label is "E2CF2D002E979BCCC51C3F1A5C314413C5A1F3C11C001D54EDAEF6FC2E0A2B3F";
    attribute INIT_3B of inst : label is "D472F4AEF496940060AA046004A0046AA0003FCB58EAA52B403B6E3226F3B2A0";
    attribute INIT_3C of inst : label is "066AC006C00AC0660A00C7A7C324C1EBC125490099B3D354D3CBD3D577007CBE";
    attribute INIT_3D of inst : label is "60009C9ADCC2FC5EFCB2740079DBDDC5DD5CDDBD9700472BCFE5CF2CCDA9C900";
    attribute INIT_3E of inst : label is "4DEBC700775D3DBC3D453D3B990094521CBE1C423C7A7C00A0660CA00C600CA6";
    attribute INIT_3F of inst : label is "33B433537900C9E5432941E6416747000AA6400A400640AA060049694FEA4F27";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(3 downto 0),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
  rom1 : if true generate
    attribute INIT_00 of inst : label is "021E421D0052514242201C42000540021C200243415352425152522200420003";
    attribute INIT_01 of inst : label is "40011A43420004201C4200034004003E1C1E033E1A424052424052420005C040";
    attribute INIT_02 of inst : label is "02434153201D52220042000340021F42521E0253021D5343431E03201A420205";
    attribute INIT_03 of inst : label is "5242524253525352435340C040030053413E1C42405242405242000340021C20";
    attribute INIT_04 of inst : label is "4352435340C0514353424342435242524253525352435340C050435342434243";
    attribute INIT_05 of inst : label is "43424253525341C050534343424252525341C051425342434243524252425352";
    attribute INIT_06 of inst : label is "525253534340C051534242424253534340C050534242424253535341C0505342";
    attribute INIT_07 of inst : label is "5243434250C051435252525243434340C051435242525243434340C051434242";
    attribute INIT_08 of inst : label is "42424251C040425352535342424251C041425252535343434250C04143525252";
    attribute INIT_09 of inst : label is "425241C040525353434342425251C040425353435342425251C0404253535353";
    attribute INIT_0A of inst : label is "5341C050524343424352525341C050524343434352525241C050524353434352";
    attribute INIT_0B of inst : label is "C050434342424342425252535352525341C05043434242434242425252535252";
    attribute INIT_0C of inst : label is "434242524242525253534352534340C050434242424342425252534352535341";
    attribute INIT_0D of inst : label is "52524252525353434353434340C051424252524242525253434353534340C051";
    attribute INIT_0E of inst : label is "5252535343434243434250C051425252524252525343434243434340C0514242";
    attribute INIT_0F of inst : label is "534343424243424251C041425253535252534343424243434250C04142525253";
    attribute INIT_10 of inst : label is "42425242425251C040525353435253434342425242424251C040525253435253";
    attribute INIT_11 of inst : label is "5242425241C040525343435343434242425242425251C0405253434353534343";
    attribute INIT_12 of inst : label is "525341C050534343425343424242525342525241C05053534342534343424252";
    attribute INIT_13 of inst : label is "515252534342424342434242525253525341C050534342424343424252525342";
    attribute INIT_14 of inst : label is "C0405251435152515352534342424342424242525353525341C0414250435042";
    attribute INIT_15 of inst : label is "5353535343400EC0405251435152515353434242424242424252525353535341";
    attribute INIT_16 of inst : label is "42524252424252534343534340C0405251435152515353434242524242424252";
    attribute INIT_17 of inst : label is "4153414353434252524252525252534343434340C04052414241524153434342";
    attribute INIT_18 of inst : label is "4250C0505341424153414343424252525252525253534343434340C040534142";
    attribute INIT_19 of inst : label is "525253434242434250C050534042415341434342525352525252525343434343";
    attribute INIT_1A of inst : label is "42425253535253535353434242424251C0504340424043404342425252535253";
    attribute INIT_1B of inst : label is "4340524043404242425253535353535343434242424251C05043405240434043";
    attribute INIT_1C of inst : label is "4252425251C0514350524043404242525343535343535343424242425251C051";
    attribute INIT_1D of inst : label is "435343434343425252425241C051424052404250424252534343534353434342";
    attribute INIT_1E of inst : label is "42505252524343434343434342425252525241C0414250534042504252525343";
    attribute INIT_1F of inst : label is "42C0414250535042505252534343424342434342525252525341C04142505350";
    attribute INIT_20 of inst : label is "525253534350534343424252C040525241424251424252525343505343434242";
    attribute INIT_21 of inst : label is "5252C04053534142425142525253434350434342424252C04053534142425142";
    attribute INIT_22 of inst : label is "52525343434251434242425252C0405353414242415252535343435143434242";
    attribute INIT_23 of inst : label is "525253C05043434052524152535343434251434242525253C050434340424241";
    attribute INIT_24 of inst : label is "4053534343424241424252525353C05043434052524152534343424241424242";
    attribute INIT_25 of inst : label is "52535343C05142424052524053434342424241424252525343C0504343405252";
    attribute INIT_26 of inst : label is "534043434242425240425252534343C051424250535340534343424252414252";
    attribute INIT_27 of inst : label is "5253434342C05142425053535043434242525240525253534343C05142425053";
    attribute INIT_28 of inst : label is "43435043424252525340525353434342C0414242504343504342424252524052";
    attribute INIT_29 of inst : label is "535343434242C04152525143435042424252525340525343434242C041525251";
    attribute INIT_2A of inst : label is "41C0414252505343424342524252535241C04152525143435142425252535350";
    attribute INIT_2B of inst : label is "41C0404253515342424242534253535341C04042525153434242425342535352";
    attribute INIT_2C of inst : label is "40C0405253514342524252535253435340C04042535143424242425342535353";
    attribute INIT_2D of inst : label is "40C0505243414352525252435243434340C05052434143425252524352434343";
    attribute INIT_2E of inst : label is "50C0505342414252535253435343424340C05052434142525252524352434343";
    attribute INIT_2F of inst : label is "50C0515342404253535353425342424250C05153424042525353534253424242";
    attribute INIT_30 of inst : label is "51C0514342405253435343424342524250C05143424052534353534253424242";
    attribute INIT_31 of inst : label is "51C0414352505243434343524352525251C04143425052534343435243525242";
    attribute INIT_32 of inst : label is "4042504350434243424242525253525341C04142525053434243435243525252";
    attribute INIT_33 of inst : label is "51424242425252525353535341C04042514351434242424252525353525341C0";
    attribute INIT_34 of inst : label is "425252534343534340C04042514351424242425252535343534340C040425143";
    attribute INIT_35 of inst : label is "4343434340C05052414241425242525253534343434340C04042514251425242";
    attribute INIT_36 of inst : label is "50C05052414241525252525353434342434250C0505241424152525252535353";
    attribute INIT_37 of inst : label is "405240525352535343434242424251C050524142415253525253434342424342";
    attribute INIT_38 of inst : label is "4353534343424242425251C05153405240535353534343434242424251C05153";
    attribute INIT_39 of inst : label is "42425252425241C04143405240534353434342424252425251C0515340524053";
    attribute INIT_3A of inst : label is "525341C04143505350434343434242425252525241C041435053505343434343";
    attribute INIT_3B of inst : label is "52425253525340C0504342424252425340C04143505350434243434242525252";
    attribute INIT_3C of inst : label is "414252425243524340C0514252425253524340C0514252425253525340C05143";
    attribute INIT_3D of inst : label is "50C0415253525343534250C0415253525343534350C0414253525343534350C0";
    attribute INIT_3E of inst : label is "435251C0405343534342434251C0405243534342434251C04052435243424342";
    attribute INIT_3F of inst : label is "4252425241C0505342434252425241C0405342434242425241C0405343534342";
  begin
  inst : RAMB16_S4
      --pragma translate_off
      generic map (
        INIT_00 => romgen_str2bv(inst'INIT_00),
        INIT_01 => romgen_str2bv(inst'INIT_01),
        INIT_02 => romgen_str2bv(inst'INIT_02),
        INIT_03 => romgen_str2bv(inst'INIT_03),
        INIT_04 => romgen_str2bv(inst'INIT_04),
        INIT_05 => romgen_str2bv(inst'INIT_05),
        INIT_06 => romgen_str2bv(inst'INIT_06),
        INIT_07 => romgen_str2bv(inst'INIT_07),
        INIT_08 => romgen_str2bv(inst'INIT_08),
        INIT_09 => romgen_str2bv(inst'INIT_09),
        INIT_0A => romgen_str2bv(inst'INIT_0A),
        INIT_0B => romgen_str2bv(inst'INIT_0B),
        INIT_0C => romgen_str2bv(inst'INIT_0C),
        INIT_0D => romgen_str2bv(inst'INIT_0D),
        INIT_0E => romgen_str2bv(inst'INIT_0E),
        INIT_0F => romgen_str2bv(inst'INIT_0F),
        INIT_10 => romgen_str2bv(inst'INIT_10),
        INIT_11 => romgen_str2bv(inst'INIT_11),
        INIT_12 => romgen_str2bv(inst'INIT_12),
        INIT_13 => romgen_str2bv(inst'INIT_13),
        INIT_14 => romgen_str2bv(inst'INIT_14),
        INIT_15 => romgen_str2bv(inst'INIT_15),
        INIT_16 => romgen_str2bv(inst'INIT_16),
        INIT_17 => romgen_str2bv(inst'INIT_17),
        INIT_18 => romgen_str2bv(inst'INIT_18),
        INIT_19 => romgen_str2bv(inst'INIT_19),
        INIT_1A => romgen_str2bv(inst'INIT_1A),
        INIT_1B => romgen_str2bv(inst'INIT_1B),
        INIT_1C => romgen_str2bv(inst'INIT_1C),
        INIT_1D => romgen_str2bv(inst'INIT_1D),
        INIT_1E => romgen_str2bv(inst'INIT_1E),
        INIT_1F => romgen_str2bv(inst'INIT_1F),
        INIT_20 => romgen_str2bv(inst'INIT_20),
        INIT_21 => romgen_str2bv(inst'INIT_21),
        INIT_22 => romgen_str2bv(inst'INIT_22),
        INIT_23 => romgen_str2bv(inst'INIT_23),
        INIT_24 => romgen_str2bv(inst'INIT_24),
        INIT_25 => romgen_str2bv(inst'INIT_25),
        INIT_26 => romgen_str2bv(inst'INIT_26),
        INIT_27 => romgen_str2bv(inst'INIT_27),
        INIT_28 => romgen_str2bv(inst'INIT_28),
        INIT_29 => romgen_str2bv(inst'INIT_29),
        INIT_2A => romgen_str2bv(inst'INIT_2A),
        INIT_2B => romgen_str2bv(inst'INIT_2B),
        INIT_2C => romgen_str2bv(inst'INIT_2C),
        INIT_2D => romgen_str2bv(inst'INIT_2D),
        INIT_2E => romgen_str2bv(inst'INIT_2E),
        INIT_2F => romgen_str2bv(inst'INIT_2F),
        INIT_30 => romgen_str2bv(inst'INIT_30),
        INIT_31 => romgen_str2bv(inst'INIT_31),
        INIT_32 => romgen_str2bv(inst'INIT_32),
        INIT_33 => romgen_str2bv(inst'INIT_33),
        INIT_34 => romgen_str2bv(inst'INIT_34),
        INIT_35 => romgen_str2bv(inst'INIT_35),
        INIT_36 => romgen_str2bv(inst'INIT_36),
        INIT_37 => romgen_str2bv(inst'INIT_37),
        INIT_38 => romgen_str2bv(inst'INIT_38),
        INIT_39 => romgen_str2bv(inst'INIT_39),
        INIT_3A => romgen_str2bv(inst'INIT_3A),
        INIT_3B => romgen_str2bv(inst'INIT_3B),
        INIT_3C => romgen_str2bv(inst'INIT_3C),
        INIT_3D => romgen_str2bv(inst'INIT_3D),
        INIT_3E => romgen_str2bv(inst'INIT_3E),
        INIT_3F => romgen_str2bv(inst'INIT_3F)
        )
      --pragma translate_on
      port map (
        DO   => DATA(7 downto 4),
        ADDR => rom_addr,
        CLK  => CLK,
        DI   => "0000",
        EN   => '1',
        SSR  => '0',
        WE   => '0'
        );
  end generate;
end RTL;
